// PluginDLL.h: Schnittstelle fr die Klasse CPluginDLL.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_PLUGINDLL_H__D932C134_F40D_11D2_B655_985AB5036126__INCLUDED_)
#define AFX_PLUGINDLL_H__D932C134_F40D_11D2_B655_985AB5036126__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "plugintypes.h"


class AFX_EXT_CLASS CPluginDLL  
{
public:
	CPluginDLL();
	CPluginDLL(CString csPath, CString csName);
	virtual ~CPluginDLL();

	virtual bool CheckOpen();

	virtual void OpenDLL();
	virtual void CloseDLL();

	virtual bool IsValidPluginDLL();

	virtual CString GetPluginInfo();
	virtual CString GetPluginName();
	virtual void ShowPluginDialog();
	virtual int GetPluginType(CString* pType = NULL);
	virtual CString GetExtraPluginName();

	virtual void SetExtraPluginName(CString csAdd);
	virtual void SetPluginDLLName(CString csPath, CString csName);
	virtual HINSTANCE GetDLLInstance();

	virtual CString GetPluginFileName();
	virtual CString GetCompletePluginFileName();

	virtual bool IsPluginNameLoaded();
	virtual bool IsPluginInfoLoaded();
	virtual bool IsPluginTypeLoaded();

	virtual void SetPluginNameLoaded(bool bLoaded = false);
	virtual void SetPluginInfoLoaded(bool bLoaded = false);
	virtual void SetPluginTypeLoaded(bool bLoaded = false);
	virtual void ReloadPluginDefinitions();

private:
	CString csDLLName;
	CString csDLLPath;
	CString csAddToPluginName;

	CString csPluginName;
	CString csPluginInfo;
	CString csPluginType;
	int iPluginType;

	bool bPluginNameLoaded;
	bool bPluginInfoLoaded;
	bool bPluginTypeLoaded;

	HINSTANCE hDLL;
};

#endif // !defined(AFX_PLUGINDLL_H__D932C134_F40D_11D2_B655_985AB5036126__INCLUDED_)
