// -----------------------------
// - vordefinierte Plugintypen -
// -----------------------------
#define PLUGINTYPE_UNKNOWN					0
#define PLUGINTYPE_PUBLISHING_BOSS			1
#define PLUGINTYPE_PUBLISHING_WORKER		2
#define PLUGINTYPE_LANGUAGEEXTENSION		3
#define PLUGINTYPE_ICONEXTENSION			4
#define PLUGINTYPE_ASSIST					5
#define PLUGINTYPE_MENUEXTENSION			6
#define PLUGINTYPE_SRVBOOKEXTENSION			7


// ---------------------------------
// - Anzeigemodies beim Serverbook -
// ---------------------------------
#define SRVBOOKMODE_GETADRESS				0
#define SRVBOOKMODE_SHOWONLY				1


// -----------------------------------------------------------
// - Routinen, die in jeder Plugin-DLL vorhanden sein mssen -
// -----------------------------------------------------------

// Routinen, die immer existieren mssen
#define PLUGINROUTINE_INFO					"GetPluginInfo"
#define PLUGINROUTINE_NAME					"GetPluginName"
#define PLUGINROUTINE_TYPEASINTEGER			"GetPluginTypeAsInteger"
#define PLUGINROUTINE_TYPEASSTRING			"GetPluginTypeAsString"
#define PLUGINROUTINE_SHOWPLUGINDLG			"ShowPluginDialog"

// Routinen, die zustzlich im Publish-Boss exisieren mssen
#define PLUGINROUTINE_EXECUTE				"ExecutePlugin"
#define PLUGINROUTINE_SETLOGININFO			"SetLoginInfo"
#define PLUGINROUTINE_SETLOGCALLBACK		"SetLOGCallback"

// Routinen, die zustzlich im Publish-Worker existieren mssen
#define PLUGINROUTINE_MAKEFOLDER			"CreateServerDirectory"
#define PLUGINROUTINE_DELETEFOLDER			"DeleteServerDirectory"
#define PLUGINROUTINE_COPYFILE				"CopyFileToServer"
#define PLUGINROUTINE_DELETEFILE			"DeleteServerFile"
#define PLUGINROUTINE_LOGIN					"Login"
#define PLUGINROUTINE_LOGOUT				"Logout"
#define PLUGINROUTINE_GETSUPPORTEDSERVICE	"GetSupportedService"
#define PLUGINROUTINE_SETFILESTATUSCALLBACK	"SetFileStatusCallback"
#define PLUGINROUTINE_GETLASTRESPONSEMSG	"GetLastResponseMessage"

// Routinen, die zustzlich im Assistenten existieren mssen
#define PLUGINROUTINE_EXECASSIST			"ExecAssist"

// Routinen, die zustzlich in der Menu-Extension existieren mssen
#define PLUGINROUTINE_CREATEMAINMENU		"CreateMainMenu"
#define PLUGINROUTINE_CREATEMDIMENU			"CreateMDIMenu"
#define PLUGINROUTINE_EXECUTEMAINMENU		"ExecuteMainMenu"
#define PLUGINROUTINE_EXECUTEMDIMENU		"ExecuteMDIMenu"

// Routinen, die zustzlich in der Serverbook-Extension existieren mssen
#define PLUGINROUTINE_SHOWSERVERBOOK		"ShowServerBook"
#define PLUGINROUTINE_GETLASTSRVBOOKENTRY	"GetLastServerBookEntry"


#define LOGACTION_ERROR						-1
#define LOGACTION_NORMAL					0
#define LOGACTION_SERVER					1

// -----------------------------------------
// - vordefinierte Routinen mit Parametern -
// -----------------------------------------

// Rckruffunktion zur Aktualisierung der Statusanzeige im Publishing-Boss
typedef void (* LPSTATUSCALLBACK)(int);
typedef void (* LPLOGCALLBACK)(CString, int, void*);

// Routinen, die immer existieren mssen
typedef void (* LPPLUGIN_INFO)(CString*);
typedef void (* LPPLUGIN_NAME)(CString*);
typedef void (* LPPLUGIN_TYPEASINTEGER)(int*);
typedef void (* LPPLUGIN_TYPEASSTRING)(CString*);
typedef void (* LPPLUGIN_SHOWDLG)();

// Routinen, die zustzlich im Publish-Boss exisieren mssen
typedef void (* LPPLUGIN_EXECUTE)(void*, CTreeCtrl*);
typedef void (* LPPLUGIN_SETLOGININFO)(CString*, CString*, int*);
typedef void (* LPPLUGIN_SETLOGCALLBACK)(LPLOGCALLBACK, void*);

// Routinen, die zustzlich im Publish-Worker existieren mssen
typedef void (* LPPLUGIN_MAKEFOLDER)(CString*, int*);
typedef void (* LPPLUGIN_DELETEFOLDER)(CString*, int*);
typedef void (* LPPLUGIN_COPYFILE)(CString*, CString*, int*);
typedef void (* LPPLUGIN_DELETEFILE)(CString*, int*);
typedef void (* LPPLUGIN_SETSTATUSCALLBACK)(LPSTATUSCALLBACK);
typedef void (* LPPLUGIN_LOGIN)(CString*, CString*, CString*, CString*, int*, int*);
typedef void (* LPPLUGIN_LOGOUT)();
typedef void (* LPPLUGIN_GETLASTRESPONSEMESSAGE)(CString*);
typedef int	 (* LPPLUGIN_GETSUPPORTEDSERVICE)();

// Routinen, die zustzlich im Assistenten existieren mssen
typedef void*(* LPPLUGIN_EXECASSIST)();

// Routinen, die zustzlich in der Menu-Extension existieren mssen
typedef void (* LPPLUGIN_CREATEMAINMENU)(void*, int, int*);
typedef void (* LPPLUGIN_CREATEMDIMENU)(void*, void*, int, int*);
typedef void (* LPPLUGIN_EXECUTEMAINMENU)(int, void*);
typedef void (* LPPLUGIN_EXECUTEMDIMENU)(int, void*, CTreeCtrl*);

// Routinen, die zustzlich in der Serverbook-Extension existieren mssen
typedef void (* LPPLUGIN_SHOWSERVERBOOK)(int);
typedef int (* LPPLUGIN_GETLASTSERVERBOOKENTRY)(void*);

