// RASConnection.h: Schnittstelle fr die Klasse CRASConnection.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_RASCONNECTION_H__90B8AB80_326E_11D4_AACE_0010600021AC__INCLUDED_)
#define AFX_RASCONNECTION_H__90B8AB80_326E_11D4_AACE_0010600021AC__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


#include "afxtempl.h"
#include "ras.h"
#include "rasdlg.h"
#include "raserror.h"

typedef struct
{
	CWnd* pWnd;
	RASDIALFUNC lpRasDialFunc;
	UINT uiMsg;
	BOOL bDialingEnded;
	BOOL bDialingCanceled;
	HRASCONN hrasconn;
} RASDIAL;

class CRASEntryNameArray;
class CRASConnArray;


class AFX_EXT_CLASS CRASConnection  
{
public:
	CRASConnection();
	virtual ~CRASConnection();

	virtual DWORD Dial(RASDIALPARAMS& dialparams, 
		RASDIALFUNC lpRasDialFunc, HRASCONN& hrasconn, 
		CWnd* pWnd = NULL, UINT uiRasDialMsg = 0, 
		BOOL bCheckAlreadyConnected = TRUE, 
		BOOL bWaitForDialEnd = TRUE);
	virtual DWORD HangUp(HRASCONN& hrasconn);

	UINT RegisterWindowMessage();

	virtual int GetAvailableRASEntries(CRASEntryNameArray& entries);
	virtual DWORD GetEntryDialParams(CString csEntry, 
		RASDIALPARAMS& params, BOOL* pbReceivedPW = NULL);

	virtual int GetConnectedRASEntries(CRASConnArray& connections);
	virtual HRASCONN IsEntryAlreadyConnected(CString csEntryName);

	virtual void FillRasDialParams(RASDIALPARAMS& params, 
		CString csEntry, CString csUser = "", CString csPW = "", 
		CString csPhone = "", CString csCallback = "", CString csDomain = "");

	virtual DWORD CreatePhonebookEntry(CWnd* pWnd);
	virtual DWORD DeletePhonebookEntry(CString csEntry);
	virtual DWORD GetErrorString(CString& csErrorMsg, UINT uiErrorVal);
};


class AFX_EXT_CLASS CRASEntryNameArray : public CArray<RASENTRYNAME, RASENTRYNAME>  
{
public:
	CRASEntryNameArray();
	virtual ~CRASEntryNameArray();

};


class AFX_EXT_CLASS CRASConnArray : public CArray<RASCONN, RASCONN>  
{
public:
	CRASConnArray();
	virtual ~CRASConnArray();

};

#endif // !defined(AFX_RASCONNECTION_H__90B8AB80_326E_11D4_AACE_0010600021AC__INCLUDED_)
