#include "WEBRoot.h"
#include "WEBProject.h"
#include "WEBFolder.h"
#include "WEBFile.h"
#include "WEBAddEntry.h"
#include "PluginArray.h"
#include "webdlldefines.h"


typedef struct
{
	CString csServer;
	CString csStartURL;
	CString csPluginFileName;
} _declspec(dllexport) SERVERADRESS;

void InitDLL(HINSTANCE hInst);
void ReleaseDLL();
bool DirectoryExists(CString csDir);

_declspec(dllexport) DWORD CALLBACK SaveLOGRTFStream(DWORD dwCookie, 
													 LPBYTE pbBuff, 
													 LONG cb, LONG *pcb);
_declspec(dllexport) DWORD CALLBACK ReadLOGRTFStream(DWORD dwCookie, 
													 LPBYTE pbBuff, 
													 LONG cb, LONG *pcb);

_declspec(dllexport) int ShowWEBRootProp(CWEBRoot* pRoot);
_declspec(dllexport) CWEBRoot* AddWEBToProject(CWEBProject* pProject);

_declspec(dllexport) CWEBFolder* AddFolder(CTreeCtrl* pTree, 
										   CWEBProject* pProject,
										   CWEBAddEntry* pAdd);
_declspec(dllexport) CWEBFile* AddFile(CTreeCtrl* pTree, 
									   CWEBProject* pProject, 
									   CWEBAddEntry* pAdd);

_declspec(dllexport) void DeleteEntry(CTreeCtrl* pTree,
									  CWEBProject* pProject);
_declspec(dllexport) void DeleteFile(CTreeCtrl* pTree,
									 CWEBProject* pProject, 
									 CStringArray* pPathArray);
_declspec(dllexport) void DeleteFolder(CTreeCtrl* pTree,
									   CWEBProject* pProject, 
									   CStringArray* pPathArray);
_declspec(dllexport) void DeleteVirtualFolder(CTreeCtrl* pTree,
											  CWEBProject* pProject);

_declspec(dllexport) void LoadAndSetPictureList(CTreeCtrl* pTree, 
												HINSTANCE hInst);
_declspec(dllexport) void ReloadPictureList(HINSTANCE hInst);
_declspec(dllexport) void SetPictureList(CTreeCtrl* pTree);

_declspec(dllexport) CWEBProject* AddProject();
_declspec(dllexport) int ShowProjectProp(CWEBProject* pProject);

_declspec(dllexport) int WEBDLLMsgBox(UINT uiMsgID, LPCSTR lpDefault, 
									  UINT uiType = MB_OK, UINT uiHelp = -1, ...);
_declspec(dllexport) CString WEBDLLGetMsgTextV(UINT uiMsgID, 
											   LPCSTR lpDefault, 
											   va_list arglist);
_declspec(dllexport) CString WEBDLLGetMsgText(UINT uiMsgID, 
											  LPCSTR lpDefault, ...);

_declspec(dllexport) HINSTANCE WEBDLLGetInstanceHandle();

_declspec(dllexport) void WEBDLLSetLanguageInstanceHandle(HINSTANCE hInst);
_declspec(dllexport) HINSTANCE WEBDLLGetLanguageInstanceHandle();
_declspec(dllexport) void WEBDLLSetNewLanguageText(CWnd* pWndParent, UINT uiID, 
												   int iLangID, CString csDefault);
