// WEBEntry.h: Schnittstelle fr die Klasse CWEBEntry.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_WEBENTRY_H__72F62AC6_EF60_11D2_B655_BFEE79725A26__INCLUDED_)
#define AFX_WEBENTRY_H__72F62AC6_EF60_11D2_B655_BFEE79725A26__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "afxtempl.h"


class AFX_EXT_CLASS CWEBEntry : public CObject
{
public:
	CString GetPropertiesAsString();
	CWEBEntry();
	virtual ~CWEBEntry();

	// ermittelt kompletten Pfad zu Eintrag ausgehend vom Root
	virtual CString GetWEBWay(CStringArray* pArray);
	virtual CString GetFolderWay(CStringArray *pArray, CWEBEntry* pStop);
	virtual CString GetStatus();
	virtual CString GetShortStatus();
	virtual int GetEntrySize();
	virtual CString GetActionAsString();

	// setzt den TreeStatus
	virtual void SetEntryTreeState(CTreeCtrl* pTree, UINT uiState = 0);
	// setzt das Baumhandle des Eintrages
	virtual void SetTreeHandle(HTREEITEM hItem);
	// setzt die erweiterten Eigenschaften des Eintrages
	virtual void SetExtendedProperties(int iProp);
	// fgt eine erweiterte Eigenschaft dem Eintrag hinzu
	virtual void AddExtendedProperties(int iProp);
	// setzt den Status des Eintrages
	virtual void SetStatus(int iStatus);
	// setzt die Eigenschaften des Eintrages
	virtual void SetProperties(LPWIN32_FIND_DATA lpw32fdProp);
	virtual void AktualisiereEntry();
	// setzt den Vater des Eintrages
	virtual void SetParent(CWEBEntry* pEntry);

	virtual void AddItemToTree(CTreeCtrl* pTree, 
		HTREEITEM hParent, HTREEITEM hInsertAfter = NULL);
	virtual void SetNewStatus(int iStatus);

	virtual void SetWEBName(CString csName);
	virtual void SetLocalName(CString csName);

	virtual void CopyEntryFrom(CWEBEntry* pEntry);

	virtual void DoUpdateFolder(CTreeCtrl* pTree);

	virtual bool EntryChanged(WIN32_FIND_DATA* findData);

	// Handle des Eintrages in Baum
	HTREEITEM hTreeItem;
	// erweiterte Eigenschaften des Eintrages
	int iProperties;
	// Status des Eintrages
	int iStatus;
	// was ist es?
	int iType;
	// ID des Eintrages
	int iID;
	int iVirtualID;
	int iNewStatus;
	// nur zum laden gedacht!
	UINT uiTreeStatus;
	// Eintragsnamen auf Server
	CString csWEBName;
	CString csLocalName;
	// Eigenschaften (wie Gre, ...) des Eintrages
	WIN32_FIND_DATA w32fdProperties;
	// "Vater" des Eintrages
	CWEBEntry* pParent;
};

#endif // !defined(AFX_WEBENTRY_H__72F62AC6_EF60_11D2_B655_BFEE79725A26__INCLUDED_)
