// WEBFolder.h: Schnittstelle fr die Klasse CWEBFolder.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_WEBFOLDER_H__BD828958_EF4B_11D2_B655_DD3644B87926__INCLUDED_)
#define AFX_WEBFOLDER_H__BD828958_EF4B_11D2_B655_DD3644B87926__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "WEBEntry.h"
#include "WEBFile.h"
#include "WEBProject.h"
#include "afxtempl.h"

// Struktur zur Verwaltung mehrerer bernahmen
typedef struct
{
	int iID;
	CString csPath;
	int iStatus;
} TAKEFROMSTRUCT;


class AFX_EXT_CLASS CWEBFolder : public CWEBEntry
{
public:
	CWEBFolder();
	CWEBFolder(CString csWEB, CString csLocal, 
		int iID, int iProp, HTREEITEM hItem);
	virtual ~CWEBFolder();

	virtual bool DeleteVirtualFolder(CTreeCtrl* pTree);
	virtual bool DeleteVirtualFolderID(CTreeCtrl* pTree, int iID);

	virtual void CopyFolderFrom(CWEBFolder* pFromFolder);
	virtual CWEBFolder* GetCurrentFolder(CTreeCtrl* pTree);
	virtual CWEBFolder* AddFolder(CString csLocal, CString csWEB, int iID, 
		int iProp, int iPos, WIN32_FIND_DATA* lpw32fdProp);
	virtual CWEBFile* AddFile(CString csLocal, CString csWEB, int iID,
		int iProp, int iPos, WIN32_FIND_DATA* lpw32fdProp);
	virtual CWEBFile* AddFile(CWEBFile* pFile, int iPos);

	virtual void AddExtendedProperties(int iProp);
	virtual int FindNextAvailableID();

	virtual void DeleteEntry(CTreeCtrl* pTree);
	virtual void DeleteFile(CTreeCtrl* pTree, int iDelID);
	virtual void DeleteFolder(CTreeCtrl* pTree, int iDelID);
	virtual void DeleteFolders(CWEBFolder* pFolder, CTreeCtrl* pTree);
	virtual void DeleteTreeItems(CTreeCtrl* pTree);

	virtual void DestroyFolders();

	virtual int IsUebernahme(int iID);

	virtual CWEBEntry* GetEntryAt(CStringArray* pPathArray);
	virtual CWEBFolder* FindFolder(HTREEITEM hItem);
	virtual CWEBFolder* FindFolder(int iFindID);
	virtual CWEBEntry* FindEntry(HTREEITEM hItem);
	virtual CWEBEntry* FindEntry(int iFindID);
	virtual int FindEntryIndex(HTREEITEM hItem);
	virtual int FindEntryIndex(int iFindID);

	virtual void SetSearchDir(CString csSearch);
	virtual void CreateTreeList(CTreeCtrl* pTree, CWEBFolder* pFolder, 
		HTREEITEM hItem);

	virtual void AddUebernahme(int iFromID, CString csPath);
	virtual void ShowProperties();

	virtual int ResetAllEntries(CTreeCtrl* pTree = NULL);
	virtual int ResetAllEntriesWithoutDlg(
		CTreeCtrl* pTree, BOOL bResetAdd = TRUE, 
		BOOL bResetUpd = TRUE, BOOL bResetDel = FALSE);

	virtual bool CheckFoldersUpdated(CTreeCtrl* pTree);

	// weitere Eintrge
	CArray<CWEBEntry*, CWEBEntry*>* pContent;
	// Array mit bernahmen
	CArray<TAKEFROMSTRUCT, TAKEFROMSTRUCT> TakeFrom;
	CString csSearchFolder;
	CWEBProject* pProject;
private:
	virtual void FindNextID(CWEBFolder* pParent, int& iCurrID);
};

#endif // !defined(AFX_WEBFOLDER_H__BD828958_EF4B_11D2_B655_DD3644B87926__INCLUDED_)
