// WEBProject.h: Schnittstelle fr die Klasse CWEBProject.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_WEBPROJECT_H__D54803A0_0B1D_11D3_B655_F175286F1126__INCLUDED_)
#define AFX_WEBPROJECT_H__D54803A0_0B1D_11D3_B655_F175286F1126__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <afxtempl.h>
#include "afxrich.h"

class CWEBRoot;
class CWEBEntry;

typedef struct
{
	CString csIgnoreName;
	BOOL bIgnoreCase;
	BOOL bCompleteDir;
} IGNOREDIRSTRUC;


class AFX_EXT_CLASS CWEBArray : public CArray<CWEBRoot*, CWEBRoot*>  
{
public:
	CWEBArray();
	virtual ~CWEBArray();
};

class AFX_EXT_CLASS CWEBIgnoreDirArray : public CArray<IGNOREDIRSTRUC, IGNOREDIRSTRUC>  
{
public:
	CWEBIgnoreDirArray();
	virtual ~CWEBIgnoreDirArray();

};

class AFX_EXT_CLASS CWEBProject  
{
public:
	CWEBProject();
	virtual ~CWEBProject();

	virtual CWEBRoot* FindRoot(HTREEITEM hItem);
	virtual CWEBRoot* GetCurrentRoot(CTreeCtrl* pTree);
	virtual int GetWEBCount();
	virtual CWEBRoot* GetRoot(int i);
	virtual CWEBRoot* AddWEBRoot(CString csWEB, CString csStart, int iProp);
	virtual int FindWEBByName(CString csWEBName, CString csStartFolder);

	virtual CWEBEntry* FindEntry(HTREEITEM hItem);
	virtual CWEBEntry* GetCurrentEntry(CTreeCtrl* pTree);

	virtual void CreateTreeList(CTreeCtrl* pTree);

	virtual void LoadLastRTF(CRichEditCtrl* pRTF);
	virtual void SetCurrentFileVersion(CString csVersion);
	virtual void ShowProperties(CTreeCtrl* pTree);
	virtual void AktualisiereProject();
	virtual void DeleteTreeList(CTreeCtrl* pTree);
	virtual void DeleteCurrentWEB(CTreeCtrl* pTree);

	virtual int GetBiggestID();
	virtual void DeleteAllWEBs();

	virtual bool LoadProject(CArchive* pArchive);
	virtual void SaveProject(CArchive* pArchive);

	virtual bool IsDirectoryIgnored(CString csDirName,
		int* iInd = NULL, IGNOREDIRSTRUC* pStruc = NULL);
	virtual bool IsDirectoryAlreadyIgnored(CString csDirName,
		BOOL bCompleteDir = FALSE, BOOL bIgnoreCase = TRUE);
	virtual bool IsDirectoryAlreadyIgnored(IGNOREDIRSTRUC ignore);
	virtual bool AddIgnoreDirectory(CString csDirName, 
		BOOL bCompleteDir = FALSE, BOOL bIgnoreCase = TRUE);
	virtual bool AddIgnoreDirectory(IGNOREDIRSTRUC ignore);
	virtual int GetIgnoreDirectorySize();
	virtual IGNOREDIRSTRUC GetIgnoreDirectory(int iInd);
	virtual void DeleteIgnoreDirectories();
	virtual void DeleteIgnoreDirectory(int iInd);

	CString csProjectName;
	CString csPluginDLLName;
	int iLastID;
	HTREEITEM hTreeItem;
	CRichEditCtrl* pRTFControl;
	CTreeCtrl* pTreeControl;
	CString csLoadedVersion;
	int iLoadedVersion;
	bool bLoadedVersionWithLOG;
	CString csLoadedFile;
	DWORD dwLOGPosInFile;
	UINT uiTreeStatus;
private:
	CWEBArray* pWEBs;
	CWEBIgnoreDirArray* pIgnoreDir;
};

#endif // !defined(AFX_WEBPROJECT_H__D54803A0_0B1D_11D3_B655_F175286F1126__INCLUDED_)
