// DateReloader.cpp : Legt die Initialisierungsroutinen fr die DLL fest.
//

#include "stdafx.h"
#include <afxdllx.h>
#include "resource.h"
#include "UpsiteRes.h"
#include "about.h"
#include "webproject.h"
#include "webroot.h"
#include "webfolder.h"
#include "webaddentry.h"
#include "webdlldefines.h"
#include <plugintypes.h>
#include "web.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

LPLOGCALLBACK lpLOGCallback = NULL;
void* pLOGParam = NULL;


static AFX_EXTENSION_MODULE DateReloaderDLL = { NULL, NULL };

extern "C" int APIENTRY
DllMain(HINSTANCE hInstance, DWORD dwReason, LPVOID lpReserved)
{
	// Entfernen Sie dies, wenn Sie lpReserved verwenden
	UNREFERENCED_PARAMETER(lpReserved);

	if (dwReason == DLL_PROCESS_ATTACH)
	{
		TRACE0("DATERELOADER.DLL Initializing!\n");
		
		// One-Time-Initialisierung der Erweiterungs-DLL
		if (!AfxInitExtensionModule(DateReloaderDLL, hInstance))
			return 0;

		// Diese DLL in Ressourcenkette einfgen
		// HINWEIS: Wird diese Erweiterungs-DLL implizit durch eine regulre
		//  MFC-DLL (wie z.B. ein ActiveX-Steuerelement) anstelle einer
		//  MFC-Anwendung eingebunden, dann mchten Sie mglicherweise diese
		//  Zeile aus DllMain entfernen und eine eigene Funktion einfgen,
		//  die von dieser Erweiterungs-DLL exportiert wird. Die regulre DLL,
		//  die diese Erweiterungs-DLL verwendet, sollte dann explizit die 
		//  Initialisierungsfunktion der Erweiterungs-DLL aufrufen. Anderenfalls 
		//  wird das CDynLinkLibrary-Objekt nicht mit der Recourcenkette der 
		//  regulren DLL verbunden, was zu ernsthaften Problemen
		//  fhren kann.

		new CDynLinkLibrary(DateReloaderDLL);
	}
	else if (dwReason == DLL_PROCESS_DETACH)
	{
		TRACE0("DATERELOADER.DLL Terminating!\n");
		// Bibliothek vor dem Aufruf der Destruktoren schlieen
		AfxTermExtensionModule(DateReloaderDLL);
	}
	return 1;   // OK
}

void AddToLOG(CString csMsg, int iAction)
{
	// gltig?
	if (lpLOGCallback)
		// ,,, aufrufen
		lpLOGCallback(csMsg, iAction, pLOGParam);
}

extern "C" void GetPluginName(CString* name)
{
	*name = "DateReloader v1.0";
}

extern "C" void GetPluginInfo(CString* info)
{
	*info = "Standard-Plugin fr Uploader v1.0 um Datumsangaben von Eintrgen zu aktualisieren.";
}

extern "C" void GetPluginTypeAsString(CString* type)
{
	*type = "PLUGINTYPE_MENUEXTENSION";
}

extern "C" void GetPluginTypeAsInteger(int* type)
{
	*type = PLUGINTYPE_MENUEXTENSION;
}

extern "C" void ShowPluginDialog()
{
	CAbout about;

	// anzeigen
	about.DoModal();
}

void ReloadDateFile(CWEBFile* pFile)
{
	if (pFile)
	{
		WIN32_FIND_DATA find;
		HANDLE handle;

		// jetzt mal den Eintrag auf Platte suchen
		handle = FindFirstFile(pFile->csLocalName, &find);
		// war alles ok?
		if (handle != INVALID_HANDLE_VALUE)
		{
			// alles bertragen
			pFile->w32fdProperties.ftCreationTime = find.ftCreationTime;
			pFile->w32fdProperties.ftLastAccessTime = find.ftLastAccessTime;
			pFile->w32fdProperties.ftLastWriteTime = find.ftLastWriteTime;
			// Suche beenden
			FindClose(handle);

			// und nun den Status abndern
			if (pFile->iStatus != WEBSTATUS_ADDED)
			{
				// wurde Entry verndert??
				if (pFile->EntryChanged(&find))
					pFile->iStatus = WEBSTATUS_CHANGED;
				else
					pFile->iStatus = WEBSTATUS_ACTIVE;
			}
		}
		else
			// sonst wurde Datei gelscht
			pFile->iStatus = WEBSTATUS_DELETED;
	}
}

void ReloadDateFolder(CWEBFolder* pFolder)
{
	// und nun aktualisieren
	if (pFolder)
	{
		CWEBEntry* pEntry = NULL;

		// alle Eintrge durchlaufen
		for (int i=0; i<pFolder->pContent->GetSize(); i++)
		{
			// den aktuellen holen
			pEntry = pFolder->pContent->GetAt(i);
			// alles ok?
			if (pEntry)
			{
				// ein Verzeichnis??
				if (pEntry->iType == WEBTYPE_FOLDER ||
					pEntry->iType == WEBTYPE_ROOT)
					// mich selbst aufrufen!
					ReloadDateFolder((CWEBFolder*)pEntry);
				else
					// oder eine Datei??
					if (pEntry->iType == WEBTYPE_FILE)
						// dann Datei aktualisieren
						ReloadDateFile((CWEBFile*)pEntry);
			}
		}
	}
}

void ExecDateReloader(CWEBProject* pProject, CTreeCtrl* pTree)
{
	// Projekt gltig?
	if (pProject)
	{
		CWEBRoot* pRoot = NULL;
		CWEBEntry* pEntry = NULL;
		CWEBFolder* pReload = NULL;

		// das aktuelle Root / Verzeichnis
		pRoot = pProject->GetCurrentRoot(pTree);
		// auch ok?
		if (pRoot)
		{
			// aktuelles Verzeichnis holen
			pEntry = pRoot->FindEntry(pTree->GetSelectedItem());
			// ist das ok?
			if (pEntry)
			{
				AddToLOG(WEBDLLGetMsgText(
					LRN_MNUEXT_ACTIONS_PROCESSWEB, 
					LRN_MNUEXT_ACTIONS_PROCESSWEB_STD, 
					pRoot->csWEBName), LOGACTION_NORMAL);

				// ein Verzeichnis
				if (pEntry->iType == WEBTYPE_FOLDER ||
					pEntry->iType == WEBTYPE_ROOT)
				{
					// und hier drin alles aktualisieren
					ReloadDateFolder((CWEBFolder*)pEntry);
					pReload = (CWEBFolder*)pEntry->pParent;
					if (!pReload)
						pReload = (CWEBFolder*)pEntry;
				}
				else
					// eine Datei???
					if (pEntry->iType == WEBTYPE_FILE)
					{
						// und hier drin alles aktualisieren
						ReloadDateFile((CWEBFile*)pEntry);
						pReload = (CWEBFolder*)pEntry->pParent;
					}

				// ganze Anzeige aktualisieren
				if (pReload)
					pReload->CheckFoldersUpdated(pTree);


				// ... alles ok!
				AddToLOG(WEBDLLGetMsgText(
					LRN_SUCESS_WEB_ENDWORK,
					LRN_SUCESS_WEB_ENDWORK_STD, 
					pRoot->csWEBName), LOGACTION_NORMAL);
			}
			else
			{
				AddToLOG(WEBDLLGetMsgText(
					LRN_ERRORS_NOCURRENTFOLDERAVAILABLE, 
					LRN_ERRORS_NOCURRENTFOLDERAVAILABLE_STD), LOGACTION_ERROR);
				// ... ansonsten Fehler
				AfxMessageBox(WEBDLLGetMsgText(
					LRN_DLG_MSG_NOCURRENTFOLDERAVAILABLE,
					LRN_DLG_MSG_NOCURRENTFOLDERAVAILABLE_STD));
			}
		}
		else
		{
			AddToLOG(WEBDLLGetMsgText(
				LRN_ERRORS_NOWEBMARKED, 
				LRN_ERRORS_NOWEBMARKED_STD), LOGACTION_ERROR);
			// ... ansonsten Fehler
			AfxMessageBox(WEBDLLGetMsgText(
				LRN_DLG_MSG_NOCURRENTWEBAVAILABLE, 
				LRN_DLG_MSG_NOCURRENTWEBAVAILABLE_STD));
		}
	}
	else
	{
		AddToLOG(WEBDLLGetMsgText(
			LRN_ERRORS_PROJECTINCORRECT, 
			LRN_ERRORS_PROJECTINCORRECT_STD), LOGACTION_ERROR);
		// ... sonst Fehler
		AfxMessageBox(WEBDLLGetMsgText(
			LRN_DLG_MSG_INCORRECTPROJECT, 
			LRN_DLG_MSG_INCORRECTPROJECT_STD));
	}
}

extern "C" void ExecuteMDIMenu(int iCommand, void* pProject, 
							   CTreeCtrl* pTree)
{
	switch (iCommand)
	{
		case 0:
			// ... und ausfhren
			ExecDateReloader((CWEBProject*)pProject, pTree);
			break;
		default:
			AddToLOG(WEBDLLGetMsgText(
				LRN_ERRORS_PLUGINNUMBERINVALID, 
				LRN_ERRORS_PLUGINNUMBERINVALID_STD), 
				LOGACTION_NORMAL);
			AfxMessageBox(WEBDLLGetMsgText(
				LRN_DLG_MSG_PLUGINNUMBERINVALID, 
				LRN_DLG_MSG_PLUGINNUMBERINVALID_STD));
			break;
	}
}

extern "C" void SetLOGCallback(LPLOGCALLBACK lpCallback, void* pParam)
{
	// Routine und Daten merken
	lpLOGCallback = lpCallback;
	pLOGParam = pParam;
}


extern "C" void CreateMainMenu(void* pMain, int iFirst, int* iCount)
{
	// kein Menpunkt hinzufgen!
	*iCount = 0;
}

extern "C" void ExecuteMainMenu(int iCommand, void* pVoid)
{
	AddToLOG(WEBDLLGetMsgText(
		LRN_ERRORS_PLUGINNUMBERINVALID, 
		LRN_ERRORS_PLUGINNUMBERINVALID_STD), 
		LOGACTION_NORMAL);
	AfxMessageBox(WEBDLLGetMsgText(
		LRN_DLG_MSG_PLUGINNUMBERINVALID, 
		LRN_DLG_MSG_PLUGINNUMBERINVALID_STD));
}

extern "C" void CreateMDIMenu(void* pMDI, void* pContextMDI, 
							  int iFirst, int* iCount)
{
	CMenu* pMainMenu = (CMenu*)pContextMDI;

	if (pMainMenu)
	{
		// ersten Menpkt eintragen
		pMainMenu->InsertMenu(ID_PROP_NORMAL, 
			MF_BYCOMMAND | MF_STRING, iFirst, 
			"DateReloader");
		pMainMenu->InsertMenu(ID_PROP_NORMAL, 
			MF_BYCOMMAND | MF_STRING | MF_SEPARATOR, 0);
	}

	*iCount = 1;
}

