// Indexxx.cpp : Legt die Initialisierungsroutinen fr die DLL fest.
//

#include "stdafx.h"
#include <afxdllx.h>
#include "resource.h"
#include "UpsiteRes.h"
#include "about.h"
#include "webproject.h"
#include "webroot.h"
#include "webfolder.h"
#include "webaddentry.h"
#include "webdlldefines.h"
#include <plugintypes.h>
#include "web.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

LPLOGCALLBACK lpLOGCallback = NULL;
void* pLOGParam = NULL;


static AFX_EXTENSION_MODULE IndexxxDLL = { NULL, NULL };

extern "C" int APIENTRY
DllMain(HINSTANCE hInstance, DWORD dwReason, LPVOID lpReserved)
{
	UNREFERENCED_PARAMETER(lpReserved);

	if (dwReason == DLL_PROCESS_ATTACH)
	{
		TRACE0("INDEXXX.DLL Initializing!\n");
		
		if (!AfxInitExtensionModule(IndexxxDLL, hInstance))
			return 0;

		new CDynLinkLibrary(IndexxxDLL);
	}
	else if (dwReason == DLL_PROCESS_DETACH)
	{
		TRACE0("INDEXXX.DLL Terminating!\n");
		AfxTermExtensionModule(IndexxxDLL);
	}
	return 1;
}

void AddToLOG(CString csMsg, int iAction)
{
	// gltig?
	if (lpLOGCallback)
		// ,,, aufrufen
		lpLOGCallback(csMsg, iAction, pLOGParam);
}

extern "C" void GetPluginName(CString* name)
{
	*name = "Indexxx! v1.0";
}

extern "C" void GetPluginInfo(CString* info)
{
	*info = "Standard-Plugin fr Uploader v1.0 um index.html bzw. default.html zu duplizieren.";
}

extern "C" void GetPluginTypeAsString(CString* type)
{
	*type = "PLUGINTYPE_MENUEXTENSION";
}

extern "C" void GetPluginTypeAsInteger(int* type)
{
	*type = PLUGINTYPE_MENUEXTENSION;
}

extern "C" void ShowPluginDialog()
{
	CAbout about;

	// anzeigen
	about.DoModal();
}

void CreateItem(CWEBFile* pOrgFile, CWEBFile* pRefFile,
				CWEBFolder* pFolder,
				CWEBAddEntry* pAddEntry, CString csName,
				CTreeCtrl* pTree)
{
	CWEBFile* pNewFile = NULL;
	int iInd;
	HTREEITEM hItem;

	// alles bentigte da?
	if (pTree && pAddEntry && pFolder)
	{
		// ist die Datei schon da?
		if (pOrgFile)
		{
			hItem = pOrgFile->hTreeItem;

			// hier nur Eigenschaften bertragen
			*pOrgFile = *pRefFile;
			pOrgFile->csWEBName = csName;
			pOrgFile->iProperties = 0;
			pOrgFile->pParent = pRefFile->pParent;
			pOrgFile->hTreeItem = hItem;
			pOrgFile->iStatus = WEBSTATUS_CHANGED;
			pOrgFile->AktualisiereEntry();
			pOrgFile->AddItemToTree(pTree, NULL);
		}
		else
			// eine Referenz gegeben?
			if (pRefFile)
			{
				// hier neuen Eintrag erzeugen und in Baum eintragen
				pNewFile = new CWEBFile(*pRefFile);
				if (pNewFile)
				{
					// neue Eigenschaften angeben
					pNewFile->csWEBName = csName;
					pNewFile->iProperties = 0;
					pNewFile->pParent = pRefFile->pParent;
					pNewFile->iStatus = WEBSTATUS_ADDED;
					// ... nun in Baum einsetzen
					pAddEntry->Sort(pFolder, csName, iInd, hItem, WEBTYPE_FILE);
					// ... und eintragen
					pFolder->AddFile(pNewFile, iInd);
					// in Baum auch einfgen
					pNewFile->AddItemToTree(pTree, pFolder->hTreeItem, hItem);
				}
			}
	}
}

void ExecIndexxxFolder(CWEBFolder* pFolder, CTreeCtrl* pTree)
{
	// alles ok?
	if (pFolder && pTree && 
		!(pFolder->iStatus & WEBSTATUS_DELETED))
	{
		CWEBAddEntry addEntry;
		int iInd;
		HTREEITEM hItem;
		CWEBFile* pIndexHTMLOrg = NULL;
		CWEBFile* pIndexHTMOrg = NULL;
		CWEBFile* pDefaultHTMLOrg = NULL;
		CWEBFile* pDefaultHTMOrg = NULL;
		CWEBFile* pIndexHTML = NULL;
		CWEBFile* pIndexHTM = NULL;
		CWEBFile* pDefaultHTML = NULL;
		CWEBFile* pDefaultHTM = NULL;
		CWEBFile* pIndexHTMLTakeFrom = NULL;
		CWEBFile* pIndexHTMTakeFrom = NULL;
		CWEBFile* pDefaultHTMLTakeFrom = NULL;
		CWEBFile* pDefaultHTMTakeFrom = NULL;
		CWEBFile* pNewFile = NULL;
		CWEBEntry* pCurrent = NULL;

		// nun mal schauen, was an Eintrgen so schon da ist!
		pIndexHTM = pIndexHTMOrg = (CWEBFile*)addEntry.Sort(
			pFolder, "index.htm", iInd, hItem, WEBTYPE_FILE);
		pIndexHTML = pIndexHTMLOrg = (CWEBFile*)addEntry.Sort(
			pFolder, "index.html", iInd, hItem, WEBTYPE_FILE);
		pDefaultHTM = pDefaultHTMOrg = (CWEBFile*)addEntry.Sort(
			pFolder, "default.htm", iInd, hItem, WEBTYPE_FILE);
		pDefaultHTML = pDefaultHTMLOrg = (CWEBFile*)addEntry.Sort(
			pFolder, "default.html", iInd, hItem, WEBTYPE_FILE);

		// sind Dateien gerade zu lschen?
		if (pIndexHTM)
			if (pIndexHTM->iStatus & WEBSTATUS_DELETED)
				pIndexHTM = NULL;
		if (pIndexHTML)
			if (pIndexHTML->iStatus & WEBSTATUS_DELETED)
				pIndexHTML = NULL;
		if (pDefaultHTM)
			if (pDefaultHTM->iStatus & WEBSTATUS_DELETED)
				pDefaultHTM = NULL;
		if (pDefaultHTML)
			if (pDefaultHTML->iStatus & WEBSTATUS_DELETED)
				pDefaultHTML = NULL;

		// ist mindestens eine dieser Dateien da??
		if (pIndexHTM || pIndexHTML ||
			pDefaultHTM || pDefaultHTML)
		{
			// hier schauen, woher alle Daten der einzelnen
			// Dateien kommen ...
			// Erst die index.htm abchecken ...
			if (!pIndexHTM)
			{
				if (pIndexHTML)
					pIndexHTMTakeFrom = pIndexHTML;
				else
					if (pDefaultHTM)
						pIndexHTMTakeFrom = pDefaultHTM;
					else
						if (pDefaultHTML)
							pIndexHTMTakeFrom = pDefaultHTML;
			}
			// ... nun die index.html abchecken ...
			if (!pIndexHTML)
			{
				if (pIndexHTM)
					pIndexHTMLTakeFrom = pIndexHTM;
				else
					if (pDefaultHTML)
						pIndexHTMLTakeFrom = pDefaultHTML;
					else
						if (pDefaultHTM)
							pIndexHTMLTakeFrom = pDefaultHTM;
			}
			// ... dann die default.htm abchecken ...
			if (!pDefaultHTM)
			{
				if (pDefaultHTML)
					pDefaultHTMTakeFrom = pDefaultHTML;
				else
					if (pIndexHTM)
						pDefaultHTMTakeFrom = pIndexHTM;
					else
						if (pIndexHTML)
							pDefaultHTMTakeFrom = pIndexHTML;
			}
			// ... und als letztes natrlich die default.html!
			if (!pDefaultHTML)
			{
				if (pDefaultHTM)
					pDefaultHTMLTakeFrom = pDefaultHTM;
				else
					if (pIndexHTML)
						pDefaultHTMLTakeFrom = pIndexHTML;
					else
						if (pIndexHTM)
							pDefaultHTMLTakeFrom = pIndexHTM;
			}

			// jetzt die Dateien evtl. einfgen

			// zuerst mal index.htm
			if (!pIndexHTM && pIndexHTMTakeFrom)
				CreateItem(pIndexHTMOrg, pIndexHTMTakeFrom, 
					pFolder, &addEntry, "index.htm", pTree);
			// ... dann die index.html
			if (!pIndexHTML && pIndexHTMLTakeFrom)
				CreateItem(pIndexHTMLOrg, pIndexHTMLTakeFrom, 
					pFolder, &addEntry, "index.html", pTree);
			// ... nun die default.htm
			if (!pDefaultHTM && pDefaultHTMTakeFrom)
				CreateItem(pDefaultHTMOrg, pDefaultHTMTakeFrom, 
					pFolder, &addEntry, "default.htm", pTree);
			// ... und am Ende die default.html
			if (!pDefaultHTML && pDefaultHTMLTakeFrom)
				CreateItem(pDefaultHTMLOrg, pDefaultHTMLTakeFrom, 
					pFolder, &addEntry, "default.html", pTree);
		}

		// nun alle weiteren Unterfolder durchlaufen und dort dasselbe machen
		for (int i=0; i<pFolder->pContent->GetSize(); i++)
		{
			// aktuellen Eintrag holen
			pCurrent = pFolder->pContent->GetAt(i);

			// ist das Ding ok und ein Dir?
			if ((pCurrent) && 
				(pCurrent->iType == WEBTYPE_FOLDER ||
				 pCurrent->iType == WEBTYPE_ROOT))
				// ... dann nochmal dasselbe machen
				ExecIndexxxFolder((CWEBFolder*)pCurrent, pTree);
		}
	}
}

void ExecIndexxx(CWEBProject* pProject, CTreeCtrl* pTree)
{
	// Projekt gltig?
	if (pProject)
	{
		CWEBRoot* pRoot = NULL;
		CWEBEntry* pEntry = NULL;
		CWEBFolder* pCurrent = NULL;
		CStringArray DirArray;

		// alles leeren?
		DirArray.RemoveAll();

		// das aktuelle Root / Verzeichnis
		pRoot = pProject->GetCurrentRoot(pTree);
		// auch ok?
		if (pRoot)
		{
			// aktuelles Verzeichnis holen
			pEntry = pRoot->FindEntry(pTree->GetSelectedItem());
			// ist das ok und ein Verzeichnis bzw. nicht zu lschen?
			if ( (pEntry) && 
				 (pEntry->iType == WEBTYPE_FOLDER ||
				  pEntry->iType == WEBTYPE_ROOT) &&
				!(pEntry->iStatus & WEBSTATUS_DELETED))
			{
				// und den Pfad dorthin holen
				pEntry->GetWEBWay(&DirArray);

				// nun alle WEB's durchlaufen
				for (int i=0; i<pProject->GetWEBCount(); i++)
				{
					// das Root holen
					pRoot = pProject->GetRoot(i);
					// alles ok?
					if (pRoot)
					{
						// bearbeite Folder
						AddToLOG(WEBDLLGetMsgText(
							LRN_MNUEXT_ACTIONS_PROCESSWEB, 
							LRN_MNUEXT_ACTIONS_PROCESSWEB_STD, 
							pRoot->csWEBName), LOGACTION_NORMAL);

						// den aktuellen Eintrag holen
						pCurrent = (CWEBFolder*)pRoot->GetEntryAt(&DirArray);
						// wurde was gefunden?
						if (pCurrent)
						{
							// dann im Folder weitermachen
							ExecIndexxxFolder(pCurrent, pTree);
							// ... und diesen aktualisieren
							if (pCurrent->pParent)
								((CWEBFolder*)pCurrent->pParent)->
									CheckFoldersUpdated(pTree);
							else
								pCurrent->CheckFoldersUpdated(pTree);
						}

						// ... alles ok!
						AddToLOG(WEBDLLGetMsgText(
							LRN_SUCESS_WEB_ENDWORK,
							LRN_SUCESS_WEB_ENDWORK_STD, 
							pRoot->csWEBName), LOGACTION_NORMAL);
					}
				}
			}
			else
			{
				AddToLOG(WEBDLLGetMsgText(
					LRN_ERRORS_NOCURRENTFOLDERAVAILABLE, 
					LRN_ERRORS_NOCURRENTFOLDERAVAILABLE_STD), LOGACTION_ERROR);
				// ... ansonsten Fehler
				AfxMessageBox(WEBDLLGetMsgText(
					LRN_DLG_MSG_NOCURRENTFOLDERAVAILABLE,
					LRN_DLG_MSG_NOCURRENTFOLDERAVAILABLE_STD));
			}
		}
		else
		{
			AddToLOG(WEBDLLGetMsgText(
				LRN_ERRORS_NOWEBMARKED, 
				LRN_ERRORS_NOWEBMARKED_STD), LOGACTION_ERROR);
			// ... ansonsten Fehler
			AfxMessageBox(WEBDLLGetMsgText(
				LRN_DLG_MSG_NOCURRENTWEBAVAILABLE, 
				LRN_DLG_MSG_NOCURRENTWEBAVAILABLE_STD));
		}
	}
	else
	{
		AddToLOG(WEBDLLGetMsgText(
			LRN_ERRORS_PROJECTINCORRECT, 
			LRN_ERRORS_PROJECTINCORRECT_STD), LOGACTION_ERROR);
		// ... sonst Fehler
		AfxMessageBox(WEBDLLGetMsgText(
			LRN_DLG_MSG_INCORRECTPROJECT, 
			LRN_DLG_MSG_INCORRECTPROJECT_STD));
	}
}

extern "C" void ExecuteMDIMenu(int iCommand, void* pProject, 
							   CTreeCtrl* pTree)
{
	switch (iCommand)
	{
		case 0:
			// ... und ausfhren
			ExecIndexxx((CWEBProject*)pProject, pTree);
			break;
		default:
			AddToLOG(WEBDLLGetMsgText(
				LRN_ERRORS_PLUGINNUMBERINVALID, 
				LRN_ERRORS_PLUGINNUMBERINVALID_STD), 
				LOGACTION_NORMAL);
			AfxMessageBox(WEBDLLGetMsgText(
				LRN_DLG_MSG_PLUGINNUMBERINVALID, 
				LRN_DLG_MSG_PLUGINNUMBERINVALID_STD));
			break;
	}
}

extern "C" void SetLOGCallback(LPLOGCALLBACK lpCallback, void* pParam)
{
	// Routine und Daten merken
	lpLOGCallback = lpCallback;
	pLOGParam = pParam;
}

extern "C" void CreateMainMenu(void* pMain, int iFirst, int* iCount)
{
	// kein Menpunkt hinzufgen!
	*iCount = 0;
}

extern "C" void ExecuteMainMenu(int iCommand, void* pVoid)
{
	AddToLOG(WEBDLLGetMsgText(
		LRN_ERRORS_PLUGINNUMBERINVALID, 
		LRN_ERRORS_PLUGINNUMBERINVALID_STD), 
		LOGACTION_NORMAL);
	AfxMessageBox(WEBDLLGetMsgText(
		LRN_DLG_MSG_PLUGINNUMBERINVALID, 
		LRN_DLG_MSG_PLUGINNUMBERINVALID_STD));
}

extern "C" void CreateMDIMenu(void* pMDI, void* pContextMDI, 
							  int iFirst, int* iCount)
{
	CMenu* pMainMenu = (CMenu*)pContextMDI;

	if (pMainMenu)
	{
		// ersten Menpkt eintragen
		pMainMenu->InsertMenu(ID_PROP_NORMAL, 
			MF_BYCOMMAND | MF_STRING, iFirst, "Indexxx!");
		pMainMenu->InsertMenu(ID_PROP_NORMAL, 
			MF_BYCOMMAND | MF_STRING | MF_SEPARATOR, 0);
	}

	*iCount = 1;
}

