// MENUEXT.cpp : Legt die Initialisierungsroutinen fr die DLL fest.
//

#include "stdafx.h"
#include <afxdllx.h>
#include "resource.h"
#include "UpsiteRes.h"
#include "about.h"
#include "webproject.h"
#include "webroot.h"
#include "webfolder.h"
#include "webaddentry.h"
#include "webdlldefines.h"
#include <plugintypes.h>
#include "newvirt.h"
#include "dirdlg.h"
#include "web.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


static AFX_EXTENSION_MODULE MENUEXTDLL = { NULL, NULL };

LPLOGCALLBACK lpLOGCallback = NULL;
void* pLOGParam = NULL;


extern "C" int APIENTRY
DllMain(HINSTANCE hInstance, DWORD dwReason, LPVOID lpReserved)
{
	// Entfernen Sie dies, wenn Sie lpReserved verwenden
	UNREFERENCED_PARAMETER(lpReserved);

	if (dwReason == DLL_PROCESS_ATTACH)
	{
		TRACE0("MENUEXT.DLL Initializing!\n");
		
		// One-Time-Initialisierung der Erweiterungs-DLL
		if (!AfxInitExtensionModule(MENUEXTDLL, hInstance))
			return 0;

		// Diese DLL in Ressourcenkette einfgen
		// HINWEIS: Wird diese Erweiterungs-DLL implizit durch eine regulre
		//  MFC-DLL (wie z.B. ein ActiveX-Steuerelement) anstelle einer
		//  MFC-Anwendung eingebunden, dann mchten Sie mglicherweise diese
		//  Zeile aus DllMain entfernen und eine eigene Funktion einfgen,
		//  die von dieser Erweiterungs-DLL exportiert wird. Die regulre DLL,
		//  die diese Erweiterungs-DLL verwendet, sollte dann explizit die 
		//  Initialisierungsfunktion der Erweiterungs-DLL aufrufen. Anderenfalls 
		//  wird das CDynLinkLibrary-Objekt nicht mit der Recourcenkette der 
		//  regulren DLL verbunden, was zu ernsthaften Problemen
		//  fhren kann.

		new CDynLinkLibrary(MENUEXTDLL);
	}
	else if (dwReason == DLL_PROCESS_DETACH)
	{
		TRACE0("MENUEXT.DLL Terminating!\n");
		// Bibliothek vor dem Aufruf der Destruktoren schlieen
		AfxTermExtensionModule(MENUEXTDLL);
	}
	return 1;   // OK
}

void AddToLOG(CString csMsg, int iAction)
{
	// gltig?
	if (lpLOGCallback)
		// ,,, aufrufen
		lpLOGCallback(csMsg, iAction, pLOGParam);
}

extern "C" void GetPluginName(CString* name)
{
	*name = "Adding Folder Menu-Extension v1.0";
}

extern "C" void GetPluginInfo(CString* info)
{
	*info = "Standard-Plugin fr Uploader v1.0 um Verzeichnisse benutzerfreundlich im Projekt anlegen zu knnen.";
}

extern "C" void GetPluginTypeAsString(CString* type)
{
	*type = "PLUGINTYPE_MENUEXTENSION";
}

extern "C" void GetPluginTypeAsInteger(int* type)
{
	*type = PLUGINTYPE_MENUEXTENSION;
}

extern "C" void ShowPluginDialog()
{
	CAbout about;

	// anzeigen
	about.DoModal();
}

extern "C" void CreateMainMenu(void* pMain, int iFirst, int* iCount)
{
	// kein Menpunkt hinzufgen!
	*iCount = 0;
}

extern "C" void ExecuteMainMenu(int iCommand, void* pVoid)
{
}

extern "C" void CreateMDIMenu(void* pMDI, void* pContextMDI, 
							  int iFirst, int* iCount)
{
	CMenu* pMainMenu = (CMenu*)pMDI;

	if (pMainMenu)
	{
		// ersten Menpkt eintragen
		pMainMenu->InsertMenu(ID_PROJECT_DELVIRT, 
			MF_BYCOMMAND | MF_STRING, iFirst+ 1, 
			WEBDLLGetMsgText(LRN_MNUEXT_TEXTS_ADDFOLDER, 
				LRN_MNUEXT_TEXTS_ADDFOLDER_STD));
		// ... und den zweiten hinterher
		pMainMenu->InsertMenu(ID_PROJECT_DELVIRT, 
			MF_BYCOMMAND | MF_STRING, iFirst,
			WEBDLLGetMsgText(LRN_MNUEXT_TEXTS_DEFINEVIRTUAL, 
				LRN_MNUEXT_TEXTS_DEFINEVIRTUAL_STD));
	}

	*iCount = 2;
}

void AddNewVirtualDir(CWEBProject* pProject, CTreeCtrl* pTree)
{
	// Projekt gltig?
	if (pProject)
	{
		CNewVirt newVirtDlg;
		CWEBRoot* pRoot = NULL;
		CWEBFolder* pFolder = NULL;
		CStringArray pathTo;
		CWEBAddEntry addIt;
		int iFlags = 0;
		bool bNext = false;
		CString csDir;

		// alles leeren
		pathTo.RemoveAll();

		// das aktuelle Root / Verzeichnis
		pRoot = pProject->GetCurrentRoot(pTree);
		// auch ok?
		if (pRoot)
		{
			pFolder = pRoot->GetCurrentFolder(pTree);
			// ist das ok?
			if (pFolder && !(pFolder->iProperties & FOLDERPROPERTIES_VIRTUAL))
			{
				// das Dialogfeld anzeigen
				if (newVirtDlg.DoModal() == IDOK)
				{
					AddToLOG(WEBDLLGetMsgText(
						LRN_MNUEXT_ACTIONS_GETTINGFOLDERFLAGS,
						LRN_MNUEXT_ACTIONS_GETTINGFOLDERFLAGS_STD), 
						LOGACTION_NORMAL);

					// Flags und Rest ermitteln
					if (newVirtDlg.m_TakeNext)
					{
						bNext = true;
						iFlags = FOLDERPROPERTIES_ALLDIR;
					}
					// das Standardflag anfgen
					iFlags |= FOLDERPROPERTIES_VIRTUAL;
					csDir = newVirtDlg.m_Path;

					// Pfad hierher holen
					pFolder->GetWEBWay(&pathTo);

					// alle WEB's durchlaufen und eintragen
					for (int i=0; i<pProject->GetWEBCount(); i++)
					{
						// hier den aktuellen Root holen
						pRoot = pProject->GetRoot(i);
						// ok?
						if (pRoot)
						{
							AddToLOG(WEBDLLGetMsgText(
								LRN_MNUEXT_ACTIONS_PROCESSWEB, 
								LRN_MNUEXT_ACTIONS_PROCESSWEB_STD, 
								pRoot->csWEBName), LOGACTION_NORMAL);

							// Folder holen
							pFolder = (CWEBFolder*)pRoot->GetEntryAt(&pathTo);

							// Folder ok?
							if (pFolder)
							{
								AddToLOG(WEBDLLGetMsgText(
									LRN_MNUEXT_ACTIONS_SETTINGFOLDERFLAGS,
									LRN_MNUEXT_ACTIONS_SETTINGFOLDERFLAGS_STD), 
									LOGACTION_NORMAL);
								// neue Flags anfgen
								pFolder->AddExtendedProperties(iFlags);
								pFolder->SetSearchDir(csDir);
								pFolder->AddUebernahme(pFolder->iID, csDir);

								AddToLOG(WEBDLLGetMsgText(
									LRN_MNUEXT_ACTIONS_ADDINGFOLDERSANDFILES,
									LRN_MNUEXT_ACTIONS_ADDINGFOLDERSANDFILES_STD), 
									LOGACTION_NORMAL);
								// alles machen
								addIt.AddLocalFolder(csDir, pFolder, 
									pTree, pFolder->iID, bNext);
								// Baum aufklappen
								pTree->Expand(pFolder->hTreeItem, TVE_EXPAND);

								// ... alles ok!
								AddToLOG(WEBDLLGetMsgText(
									LRN_SUCESS_WEB_ENDWORK,
									LRN_SUCESS_WEB_ENDWORK_STD, 
									pRoot->csWEBName), LOGACTION_NORMAL);
							}
							else
								// ... Fehler beim Folder holen!
								AddToLOG(WEBDLLGetMsgText(
									LRN_ERRORS_FOLDERNOTEXISTS, 
									LRN_ERRORS_FOLDERNOTEXISTS_STD,
									pRoot->csWEBName), LOGACTION_ERROR);
						}
						else
							// ... Fehler beim Folder holen!
							AddToLOG(WEBDLLGetMsgText(
								LRN_ERRORS_WEBNOTNOTICED,
								LRN_ERRORS_WEBNOTNOTICED_STD), 
								LOGACTION_ERROR);
					}
				}
			}
			else
			{
				if (pFolder)
				{
					AddToLOG(WEBDLLGetMsgText(
						LRN_ERRORS_VIRTUALALREADYDEFINED,
						LRN_ERRORS_VIRTUALALREADYDEFINED_STD), LOGACTION_ERROR);
					// ... ansonsten Fehler (schon da)
					AfxMessageBox(WEBDLLGetMsgText(
						LRN_DLG_MSG_VIRTUALALREADYDEFINED,
						LRN_DLG_MSG_VIRTUALALREADYDEFINED_STD));
				}
				else
				{
					AddToLOG(WEBDLLGetMsgText(
						LRN_ERRORS_NOCURRENTFOLDERAVAILABLE, 
						LRN_ERRORS_NOCURRENTFOLDERAVAILABLE_STD), LOGACTION_ERROR);
					// ... ansonsten Fehler
					AfxMessageBox(WEBDLLGetMsgText(
						LRN_DLG_MSG_NOCURRENTFOLDERAVAILABLE,
						LRN_DLG_MSG_NOCURRENTFOLDERAVAILABLE_STD));
				}
			}
		}
		else
		{
			AddToLOG(WEBDLLGetMsgText(
				LRN_ERRORS_NOWEBMARKED, 
				LRN_ERRORS_NOWEBMARKED_STD), LOGACTION_ERROR);
			// ... ansonsten Fehler
			AfxMessageBox(WEBDLLGetMsgText(
				LRN_DLG_MSG_NOCURRENTWEBAVAILABLE, 
				LRN_DLG_MSG_NOCURRENTWEBAVAILABLE_STD));
		}
	}
	else
	{
		AddToLOG(WEBDLLGetMsgText(
			LRN_ERRORS_PROJECTINCORRECT, 
			LRN_ERRORS_PROJECTINCORRECT_STD), LOGACTION_ERROR);
		// ... sonst Fehler
		AfxMessageBox(WEBDLLGetMsgText(
			LRN_DLG_MSG_INCORRECTPROJECT, 
			LRN_DLG_MSG_INCORRECTPROJECT_STD));
	}
}

void AddNewDir(CWEBProject* pProject, CTreeCtrl* pTree)
{
	// Projekt gltig?
	if (pProject)
	{
		CDirDlg newDlg;
		CWEBRoot* pRoot = NULL;
		CWEBFolder* pFolder = NULL;
		CStringArray pathTo;
		CWEBAddEntry addIt;
		CString csDir;
		int iAnswer;
		int iID;

		// alles leeren
		pathTo.RemoveAll();

		// das aktuelle Root / Verzeichnis
		pRoot = pProject->GetCurrentRoot(pTree);
		// auch ok?
		if (pRoot)
		{
			pFolder = pRoot->GetCurrentFolder(pTree);
			// ist das ok?
			if (pFolder)
			{
				// das Dialogfeld anzeigen
				if (newDlg.DoModal() == IDOK)
				{
					// Pfad holen
					csDir = newDlg.m_DirName;
					// ist das Ding schon da?
					iAnswer = addIt.FindEntry(pProject, 
						&pathTo, csDir, WEBTYPE_FOLDER);

					// soll berschrieben werden?
					if (iAnswer == IDYES)
					{
						// Pfad hierher holen
						pFolder->GetWEBWay(&pathTo);

						// alle WEB's durchlaufen und eintragen
						for (int i=0; i<pProject->GetWEBCount(); i++)
						{
							// hier den aktuellen Root holen
							pRoot = pProject->GetRoot(i);

							// ok?
							if (pRoot)
							{
								// Folder holen
								pFolder = (CWEBFolder*)pRoot->GetEntryAt(&pathTo);

								// Folder ok?
								if (pFolder)
								{
									AddToLOG(WEBDLLGetMsgText(
										LRN_MNUEXT_ACTIONS_ADDINGFOLDER,
										LRN_MNUEXT_ACTIONS_ADDINGFOLDER_STD), 
										LOGACTION_NORMAL);
									// nchste ID holen
									iID = pRoot->FindNextAvailableID();
									// eintragen
									addIt.AddFolder(pTree, pFolder, 
										"", csDir, iID, 
										FOLDERPROPERTIES_DIRONLY, NULL);
									// Baum aufklappen
									pTree->Expand(pFolder->hTreeItem, TVE_EXPAND);

									// ... alles ok!
									AddToLOG(WEBDLLGetMsgText(
										LRN_SUCESS_WEB_ENDWORK,
										LRN_SUCESS_WEB_ENDWORK_STD, 
										pRoot->csWEBName), LOGACTION_NORMAL);
								}
								else
									// ... Fehler beim Folder holen!
									AddToLOG(WEBDLLGetMsgText(
										LRN_ERRORS_FOLDERNOTEXISTS, 
										LRN_ERRORS_FOLDERNOTEXISTS_STD, 
										pRoot->csWEBName), LOGACTION_ERROR);
							}
							else
								// ... Fehler beim Folder holen!
								AddToLOG(WEBDLLGetMsgText(
									LRN_ERRORS_WEBNOTNOTICED,
									LRN_ERRORS_WEBNOTNOTICED_STD), LOGACTION_ERROR);
						}
					}
				}
			}
		}
		else
		{
			AddToLOG(WEBDLLGetMsgText(
				LRN_ERRORS_NOWEBMARKED, 
				LRN_ERRORS_NOWEBMARKED_STD), LOGACTION_ERROR);
			// ... ansonsten Fehler
			AfxMessageBox(WEBDLLGetMsgText(
				LRN_DLG_MSG_NOCURRENTWEBAVAILABLE, 
				LRN_DLG_MSG_NOCURRENTWEBAVAILABLE_STD));
		}
	}
	else
	{
		AddToLOG(WEBDLLGetMsgText(
			LRN_ERRORS_PROJECTINCORRECT,
			LRN_ERRORS_PROJECTINCORRECT_STD), LOGACTION_ERROR);
		// ... sonst Fehler
		AfxMessageBox(WEBDLLGetMsgText(
			LRN_DLG_MSG_INCORRECTPROJECT, 
			LRN_DLG_MSG_INCORRECTPROJECT_STD));
	}
}

extern "C" void ExecuteMDIMenu(int iCommand, void* pProject, 
							   CTreeCtrl* pTree)
{
	switch (iCommand)
	{
		case 0:
			// neues anlegen
			AddNewVirtualDir((CWEBProject*)pProject, pTree);
			break;
		case 1:
			AddNewDir((CWEBProject*)pProject, pTree);
			break;
		default:
			AddToLOG(WEBDLLGetMsgText(
				LRN_ERRORS_PLUGINNUMBERINVALID, 
				LRN_ERRORS_PLUGINNUMBERINVALID_STD), 
				LOGACTION_NORMAL);
			AfxMessageBox(WEBDLLGetMsgText(
				LRN_DLG_MSG_PLUGINNUMBERINVALID, 
				LRN_DLG_MSG_PLUGINNUMBERINVALID_STD));
			break;
	}
}

extern "C" void SetLOGCallback(LPLOGCALLBACK lpCallback, void* pParam)
{
	// Routine und Daten merken
	lpLOGCallback = lpCallback;
	pLOGParam = pParam;
}
