// NewVirt.cpp: Implementierungsdatei
//

#include "stdafx.h"
#include "NewVirt.h"
#include "languagedefs.h"
#include "languagestd.h"
#include "web.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// Dialogfeld CNewVirt 


CNewVirt::CNewVirt(CWnd* pParent /*=NULL*/)
	: CDialog(CNewVirt::IDD, pParent)
{
	//{{AFX_DATA_INIT(CNewVirt)
	m_Path = _T("");
	m_TakeNext = TRUE;
	//}}AFX_DATA_INIT
}


void CNewVirt::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CNewVirt)
	DDX_Text(pDX, IDC_PATH, m_Path);
	DDX_Check(pDX, IDC_TAKENEXT, m_TakeNext);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CNewVirt, CDialog)
	//{{AFX_MSG_MAP(CNewVirt)
	ON_EN_CHANGE(IDC_PATH, OnChangePath)
	ON_BN_CLICKED(IDC_FINDFOLDER, OnFindfolder)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// Behandlungsroutinen fr Nachrichten CNewVirt 

void CNewVirt::OnChangePath() 
{
	// alles testen
	CheckFolder();
}

void CNewVirt::CheckFolder()
{
	CString csText;

	// Eingabefeld holen
	CEdit* pEdit = (CEdit*)GetDlgItem(IDC_PATH);
	CButton* pOK = (CButton*)GetDlgItem(IDOK);
	// alles ok?
	ASSERT_VALID(pEdit);
	ASSERT_VALID(pOK);

	if (pEdit && pOK)
	{
		// Text holen
		pEdit->GetWindowText(csText);

		if (csText.GetLength())
			pOK->EnableWindow(true);
		else
			pOK->EnableWindow(false);
	}
}

void CNewVirt::OnFindfolder()
{
	CEdit* pEdit = (CEdit*)GetDlgItem(IDC_PATH);
	// alles ok?
	ASSERT_VALID(pEdit);

	// das Dlg anzeigen
	if (setFolder.DoModal() == IDOK && pEdit)
	{
		// letztes anzeigen
		pEdit->SetWindowText(setFolder.csLastDirectory);
		// alles testen
		CheckFolder();
	}
}

BOOL CNewVirt::OnInitDialog() 
{
	CDialog::OnInitDialog();

	// alle Texte abndern
	WEBDLLSetNewLanguageText(this, IDC_STATIC_ENTRYFOLDER, 
		LRN_STATIC_LOCALFOLDER, LRN_STATIC_LOCALFOLDER_STD);
	WEBDLLSetNewLanguageText(this, IDC_STATIC_FLAGS, 
		LRN_STATIC_FLAGS, LRN_STATIC_FLAGS_STD);
	WEBDLLSetNewLanguageText(this, IDC_FINDFOLDER, 
		LRN_BUTTONS_BROWSE, LRN_BUTTONS_BROWSE_STD);
	WEBDLLSetNewLanguageText(this, IDC_TAKENEXT, 
		LRN_COMBOBOXES_TAKEALLFOLDERS, LRN_COMBOBOXES_TAKEALLFOLDERS_STD);
	WEBDLLSetNewLanguageText(this, IDOK, LRN_BUTTONS_OK, LRN_BUTTONS_OK_STD);
	WEBDLLSetNewLanguageText(this, IDCANCEL, LRN_BUTTONS_CANCEL, LRN_BUTTONS_CANCEL_STD);
	SetWindowText(WEBDLLGetMsgText(LRN_MNUEXT_TEXTS_DEFINEVIRTUAL, 
		LRN_MNUEXT_TEXTS_DEFINEVIRTUAL_STD));

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX-Eigenschaftenseiten sollten FALSE zurckgeben
}


