// PUBDISK.cpp : Legt die Initialisierungsroutinen fr die DLL fest.
//

#include "stdafx.h"
#include <afxdllx.h>

#include "resource.h"
#include "about.h"
#include <plugintypes.h>
#include "afxinet.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


static AFX_EXTENSION_MODULE PUBDISKDLL = { NULL, NULL };

extern "C" int APIENTRY
DllMain(HINSTANCE hInstance, DWORD dwReason, LPVOID lpReserved)
{
	// Entfernen Sie dies, wenn Sie lpReserved verwenden
	UNREFERENCED_PARAMETER(lpReserved);

	if (dwReason == DLL_PROCESS_ATTACH)
	{
		TRACE0("PUBDISK.DLL Initializing!\n");
		
		// One-Time-Initialisierung der Erweiterungs-DLL
		if (!AfxInitExtensionModule(PUBDISKDLL, hInstance))
			return 0;

		// Diese DLL in Ressourcenkette einfgen
		// HINWEIS: Wird diese Erweiterungs-DLL implizit durch eine regulre
		//  MFC-DLL (wie z.B. ein ActiveX-Steuerelement) anstelle einer
		//  MFC-Anwendung eingebunden, dann mchten Sie mglicherweise diese
		//  Zeile aus DllMain entfernen und eine eigene Funktion einfgen,
		//  die von dieser Erweiterungs-DLL exportiert wird. Die regulre DLL,
		//  die diese Erweiterungs-DLL verwendet, sollte dann explizit die 
		//  Initialisierungsfunktion der Erweiterungs-DLL aufrufen. Anderenfalls 
		//  wird das CDynLinkLibrary-Objekt nicht mit der Recourcenkette der 
		//  regulren DLL verbunden, was zu ernsthaften Problemen
		//  fhren kann.

		new CDynLinkLibrary(PUBDISKDLL);
	}
	else if (dwReason == DLL_PROCESS_DETACH)
	{
		TRACE0("PUBDISK.DLL Terminating!\n");
		// Bibliothek vor dem Aufruf der Destruktoren schlieen
		AfxTermExtensionModule(PUBDISKDLL);
	}
	return 1;   // OK
}

extern "C" void GetLastResponseMessage(CString* csMsg)
{
	if (csMsg)
		*csMsg = "Nothing!";
}

extern "C" void GetPluginName(CString* name)
{
	*name = "Standard-Disc-Publishing-Worker v1.0";
}

extern "C" void GetPluginInfo(CString* info)
{
	*info = "Standard-Plugin fr Uploader v1.0 um Dateien auf Festplatte publizieren zu knnen.";
}

extern "C" void GetPluginTypeAsString(CString* type)
{
	*type = "PLUGINTYPE_PUBLISHING_WORKER";
}

extern "C" void GetPluginTypeAsInteger(int* type)
{
	*type = PLUGINTYPE_PUBLISHING_WORKER;
}

extern "C" void ShowPluginDialog()
{
	CAbout about;

	// anzeigen
	about.DoModal();
}

extern "C" void CreateServerDirectory(CString* csFolder, int* piRes)
{
	// alles ok!
	*piRes = 0;

	// ... und erzeugen
	*piRes = CreateDirectory(*csFolder, NULL);

	// war alles ok?
	if (!*piRes)
		// N! Fehler holen
		*piRes = GetLastError();
	else
		// ansonsten ging alles gut!
		*piRes = 0;
}

extern "C" void DeleteServerDirectory(CString* csFolder, int* piRes)
{
	// alles ok!
	*piRes = 0;

	// ... und lschen
	*piRes = RemoveDirectory(*csFolder);

	// war alles ok?
	if (!*piRes)
		// N! Fehler holen
		*piRes = GetLastError();
	else
		// ansonsten ging alles gut!
		*piRes = 0;
}

extern "C" void CopyFileToServer(CString* csLocal, 
								 CString* csServer, int* piRes)
{
	// alles ok!
	*piRes = 0;

	// ... und kopieren auslsen
	*piRes = CopyFile(*csLocal, *csServer, false);

	// war alles ok?
	if (!*piRes)
		// N! Fehler holen
		*piRes = GetLastError();
	else
		// ansonsten ging alles gut!
		*piRes = 0;
}

extern "C" void DeleteServerFile(CString* csFile, int* piRes)
{
	// alles ok!
	*piRes = 0;

	// Datei auf Server lschen
	*piRes = DeleteFile(*csFile);

	// war alles ok?
	if (!*piRes)
		// N! Fehler holen
		*piRes = GetLastError();
	else
		// ansonsten ging alles gut!
		*piRes = 0;
}

extern "C" void Login(CString* csServer, CString* csFolder, CString* csUser,
					  CString* csPW, int* piPort, int* piRes)
{
	// alles war ok!
	*piRes = 0;
}

extern "C" void Logout()
{
}

extern "C" void SetFileStatusCallback(LPSTATUSCALLBACK lpCallback)
{
}

extern "C" int GetSupportedService()
{
	return AFX_INET_SERVICE_FILE;
}


