// PUBFTP.cpp : Legt die Initialisierungsroutinen fr die DLL fest.
//

#include "stdafx.h"
#include <afxdllx.h>

#include "resource.h"
#include "about.h"
#include "afxinet.h"
#include <plugintypes.h>
#include "ftpdefs.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

static AFX_EXTENSION_MODULE PUBFTPDLL = { NULL, NULL };

extern "C" int APIENTRY
DllMain(HINSTANCE hInstance, DWORD dwReason, LPVOID lpReserved)
{
	// Entfernen Sie dies, wenn Sie lpReserved verwenden
	UNREFERENCED_PARAMETER(lpReserved);

	if (dwReason == DLL_PROCESS_ATTACH)
	{
		TRACE0("PUBFTP.DLL Initializing!\n");
		
		// One-Time-Initialisierung der Erweiterungs-DLL
		if (!AfxInitExtensionModule(PUBFTPDLL, hInstance))
			return 0;

		// Diese DLL in Ressourcenkette einfgen
		// HINWEIS: Wird diese Erweiterungs-DLL implizit durch eine regulre
		//  MFC-DLL (wie z.B. ein ActiveX-Steuerelement) anstelle einer
		//  MFC-Anwendung eingebunden, dann mchten Sie mglicherweise diese
		//  Zeile aus DllMain entfernen und eine eigene Funktion einfgen,
		//  die von dieser Erweiterungs-DLL exportiert wird. Die regulre DLL,
		//  die diese Erweiterungs-DLL verwendet, sollte dann explizit die 
		//  Initialisierungsfunktion der Erweiterungs-DLL aufrufen. Anderenfalls 
		//  wird das CDynLinkLibrary-Objekt nicht mit der Recourcenkette der 
		//  regulren DLL verbunden, was zu ernsthaften Problemen
		//  fhren kann.

		new CDynLinkLibrary(PUBFTPDLL);
	}
	else if (dwReason == DLL_PROCESS_DETACH)
	{
		TRACE0("PUBFTP.DLL Terminating!\n");
		// Bibliothek vor dem Aufruf der Destruktoren schlieen
		AfxTermExtensionModule(PUBFTPDLL);
	}
	return 1;   // OK
}

extern "C" void GetPluginName(CString* name)
{
	*name = "Standard-FTP-Publishing-Worker v1.0";
}

extern "C" void GetPluginInfo(CString* info)
{
	*info = "Standard-Plugin fr Uploader v1.0 um Dateien per FTP publizieren zu knnen.";
}

extern "C" void GetPluginTypeAsString(CString* type)
{
	*type = "PLUGINTYPE_PUBLISHING_WORKER";
}

extern "C" void GetPluginTypeAsInteger(int* type)
{
	*type = PLUGINTYPE_PUBLISHING_WORKER;
}

extern "C" void ShowPluginDialog()
{
	CAbout about;

	// anzeigen
	about.DoModal();
}

CString ConvertToServerFormat(CString csEntry)
{
	CString csNew;

	// alles durchlaufen und aus "\" einen "/" machen
	for (int i=0; i<csEntry.GetLength(); i++)
	{
		// ein "\"?
		if (csEntry.GetAt(i) == '\\')
			// einen Slash anfgen
			csNew = csNew+ "/";
		else
			// sonst bernehmen
			csNew = csNew+ csEntry.GetAt(i);
	}

	// raus damit!
	return csNew;
}

void SaveLastResponseMsg()
{
	DWORD dwError;
	LPSTR lpMsg;
	DWORD dwSize = 512;

	// Buffer allokieren
	lpMsg = csLastRespondMsg.GetBuffer(512);

	// dann die richtige Routine zur Ermittlung aufrufen
	InternetGetLastResponseInfo(&dwError, lpMsg, &dwSize);

	// am Ende das ganze wieder zusammenfahren
	csLastRespondMsg.ReleaseBuffer(dwSize);
}

extern "C" void GetLastResponseMessage(CString* csMsg)
{
	// letzte Meldung rausliefern
	*csMsg = csLastRespondMsg;
}

extern "C" void CreateServerDirectory(CString* csFolder, int* piRes)
{
	BOOL bRes;

	// alles ok!
	*piRes = 1;

	// ist eine Verbindung da?
	if (pINetSession && pFTPConnection)
	{
		// in Serverformat konvertieren
		CString csServer = ConvertToServerFormat(*csFolder);

		// ... und erzeugen
		*piRes = pFTPConnection->CreateDirectory(csServer);

		// war alles ok?
		if (!*piRes)
		{
			// N! Fehler holen
			*piRes = GetLastError();

			if (*piRes == ERROR_INTERNET_EXTENDED_ERROR)
			{
				// letzte Meldung speichern
				SaveLastResponseMsg();
				*piRes = ERROR_EXTENDED_ERROR;

				if (pFTPFind)
				{
					// noch nachschauen, ob das Ding schon da ist!
					bRes = pFTPFind->FindFile(*csFolder, 
						INTERNET_FLAG_RELOAD | INTERNET_FLAG_EXISTING_CONNECT);

					while (bRes)
					{
						// Eintrag holen
						bRes = pFTPFind->FindNextFile();

						// ein Verzeichnis?
						if (pFTPFind->IsDirectory())
							// ... dann war's schon da!
							*piRes = ERROR_ALREADY_EXISTS;
					}

					// Suche beenden
					pFTPFind->Close();
				}
			}
		}
		else
			// ansonsten ging alles gut!
			*piRes = 0;
	}
}

extern "C" void DeleteServerDirectory(CString* csFolder, int* piRes)
{
	BOOL bRes;

	// alles ok!
	*piRes = 1;

	// Verbindung erstellt?
	if (pINetSession && pFTPConnection)
	{
		// in Serverformat konvertieren
		CString csServer = ConvertToServerFormat(*csFolder);

		// ... und lschen
		*piRes = pFTPConnection->RemoveDirectory(csServer);

		// war alles ok?
		if (!*piRes)
		{
			// N! Fehler holen
			*piRes = GetLastError();

			if (*piRes == ERROR_INTERNET_EXTENDED_ERROR)
			{
				// letzte Meldung speichern
				SaveLastResponseMsg();
				*piRes = ERROR_EXTENDED_ERROR;

				if (pFTPFind)
				{
					// noch nachschauen, ob das Ding schon weg ist!
					bRes = pFTPFind->FindFile(*csFolder, 
						INTERNET_FLAG_RELOAD | INTERNET_FLAG_EXISTING_CONNECT);

					// Verzeichnis wurde schon gelscht!
					if (!bRes)
						*piRes = ERROR_PATH_NOT_FOUND;

					// Suche beenden
					pFTPFind->Close();
				}
			}
		}
		else
			// ansonsten ging alles gut!
			*piRes = 0;
	}
}

extern "C" void CopyFileToServer(CString* csLocal, 
								 CString* csServer, int* piRes)
{
	// alles ok!
	*piRes = 1;

	// eine Verbindung erstellt?
	if (pINetSession && pFTPConnection)
	{
		// in Serverformat konvertieren
		CString csNewServer = ConvertToServerFormat(*csServer);

		// ... und kopieren auslsen
		*piRes = pFTPConnection->PutFile(*csLocal, csNewServer);

		// war alles ok?
		if (!*piRes)
		{
			// N! Fehler holen
			*piRes = GetLastError();

			if (*piRes == ERROR_INTERNET_EXTENDED_ERROR)
			{
				// letzte Meldung speichern
				SaveLastResponseMsg();
				*piRes = ERROR_EXTENDED_ERROR;
			}
		}
		else
			// ansonsten ging alles gut!
			*piRes = 0;
	}
}

extern "C" void DeleteServerFile(CString* csFile, int* piRes)
{
	BOOL bRes;

	// alles ok!
	*piRes = 1;

	// Verbindung da?
	if (pINetSession && pFTPConnection)
	{
		// in Serverformat konvertieren
		CString csServer = ConvertToServerFormat(*csFile);

		// Datei auf Server lschen
		*piRes = pFTPConnection->Remove(csServer);

		// war alles ok?
		if (!*piRes)
		{
			// N! Fehler holen
			*piRes = GetLastError();

			if (*piRes == ERROR_INTERNET_EXTENDED_ERROR)
			{
				// letzte Meldung speichern
				SaveLastResponseMsg();
				*piRes = ERROR_EXTENDED_ERROR;

				if (pFTPFind)
				{
					// noch nachschauen, ob das Ding schon weg ist!
					bRes = pFTPFind->FindFile(*csFile, 
						INTERNET_FLAG_RELOAD | INTERNET_FLAG_EXISTING_CONNECT);

					// Verzeichnis wurde schon gelscht!
					if (!bRes)
						*piRes = ERROR_FILE_NOT_FOUND;

					// Suche beenden
					pFTPFind->Close();
				}
			}
		}
		else
			// ansonsten ging alles gut!
			*piRes = 0;
	}
}

extern "C" void Login(CString* csServer, CString* csFolder, CString* csUser,
					  CString* csPW, int* piPort, int* piRes)
{
	// Fehlerchen!
	*piRes = 1;

	// neue Internet-Session erzeugen
	pINetSession = new CInternetSession("Upsite-Plugin");
	// alles ok?
	if (pINetSession)
	{
		try
		{
			// in Serverformat konvertieren
			CString csConverted = ConvertToServerFormat(*csFolder);

			// ... dann ins FTP-Net einloggen
			pFTPConnection = pINetSession->GetFtpConnection(
				*csServer, *csUser, *csPW);
			// ... ins MainDir wechseln
			pFTPConnection->SetCurrentDirectory(csConverted);

			// noch was zum suchen einrichten
			pFTPFind = new CFtpFileFind(pFTPConnection);
		}
		catch (CInternetException* pEx)
		{
			// Abfangen von WinINet Fehlern
			TCHAR szErr[1024];
			if (pEx->GetErrorMessage(szErr, 1024))
				AfxMessageBox(szErr, MB_OK);
			pEx->Delete();

			// und bertragen
			csLastRespondMsg = szErr;

			// alles lschen
			pFTPConnection = NULL;
			// INet-Session auch beenden
			pINetSession->Close();
			delete pINetSession;
			pINetSession = NULL;
		}

		// gltig?
		if (pFTPConnection)
			// alles war ok!
			*piRes = 0;
	}
}

extern "C" void Logout()
{
	// ist eine Verbindung aktiv?
	if (pINetSession && pFTPConnection)
	{
		// die Suchen-Routine abbrechen
		delete pFTPFind;
		pFTPFind = NULL;

		// erst FTP-Verbindung abbrechen
		pFTPConnection->Close();
		delete pFTPConnection;
		pFTPConnection = NULL;
		// und jetzt die Session beenden
		pINetSession->Close();
		delete pINetSession;
		pINetSession = NULL;
	}
}

extern "C" void SetFileStatusCallback(LPSTATUSCALLBACK lpCallback)
{
}

extern "C" int GetSupportedService()
{
	return AFX_INET_SERVICE_FTP;
}
