// AddEntry.cpp: Implementierungsdatei
//

#include "stdafx.h"
#include "AddEntry.h"
#include "PubWorkerPluginDLL.h"
#include "afxinet.h"
#include "tools.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// Dialogfeld CAddEntry 


CAddEntry::CAddEntry(CWnd* pParent /*=NULL*/)
	: CDialog(CAddEntry::IDD, pParent)
{
	//{{AFX_DATA_INIT(CAddEntry)
	m_ServerName = _T("");
	m_ServerStartFolder = _T("");
	m_AdressName = _T("");
	//}}AFX_DATA_INIT

	m_csPluginDLL = "";
	pAllPlugins = GetCurrentPluginArray();
}


void CAddEntry::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAddEntry)
	DDX_Text(pDX, IDC_SERVERNAME, m_ServerName);
	DDV_MaxChars(pDX, m_ServerName, 128);
	DDX_Text(pDX, IDC_SERVERSTARTFOLDER, m_ServerStartFolder);
	DDV_MaxChars(pDX, m_ServerStartFolder, 128);
	DDX_Text(pDX, IDC_ADRESSNAME, m_AdressName);
	DDV_MaxChars(pDX, m_AdressName, 128);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CAddEntry, CDialog)
	//{{AFX_MSG_MAP(CAddEntry)
	ON_EN_CHANGE(IDC_SERVERSTARTFOLDER, OnChangeServerstartfolder)
	ON_EN_CHANGE(IDC_SERVERNAME, OnChangeServername)
	ON_CBN_SELCHANGE(IDC_WORKERPLUGINCOMBO, OnSelchangeWorkerplugincombo)
	ON_EN_CHANGE(IDC_ADRESSNAME, OnChangeAdressname)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// Behandlungsroutinen fr Nachrichten CAddEntry 

void CAddEntry::FindProtocol()
{
	CEdit* pEdit1 = (CEdit*)GetDlgItem(IDC_SERVERNAME);
	CEdit* pEdit2 = (CEdit*)GetDlgItem(IDC_SERVERSTARTFOLDER);
	CComboBox* pBox = (CComboBox*)GetDlgItem(IDC_WORKERPLUGINCOMBO);
	CPubWorkerPluginDLL* pPlugin;
	CString csNew1;
	CString csNew2;
	int iInd;

	// alles durchcheckcen
	ASSERT_VALID(pEdit1);
	ASSERT_VALID(pEdit2);
	ASSERT_VALID(pBox);

	// gltig?
	if (pBox && pEdit1 && pEdit2)
	{
		// Index holen
		iInd = pBox->GetItemData(pBox->GetCurSel());
		// den Plugin holen
		pPlugin = (CPubWorkerPluginDLL*)InternalPlugins.GetPluginAt(iInd);

		// unterschiedlich?
		if (iInd != iOldPlugin)
		{
			if (pPlugin)
			{
				// alle Protokolle durchlaufen
				switch (pPlugin->GetSupportedService())
				{
					case AFX_INET_SERVICE_FTP:
						csNew1 = "ftp://ftp.server.de/";
						csNew2 = "/";
						break;
					case AFX_INET_SERVICE_HTTP:
						csNew1 = "http://www.server.de/";
						csNew2 = "/";
						break;
					case AFX_INET_SERVICE_HTTPS:
						csNew1 = "https://www.server.de/";
						csNew2 = "/";
						break;
					case AFX_INET_SERVICE_GOPHER:
						csNew1 = "gopher://";
						csNew2 = "/";
						break;
					case AFX_INET_SERVICE_FILE:
						csNew1 = "C:\\";
						csNew2 = "C:\\";
						break;
					default:
						csNew1 = "";
						csNew2 = "";
						break;
				}

				// neuen Text setzen
				pEdit1->SetWindowText(csNew1);
				pEdit2->SetWindowText(csNew2);
				m_csOldFolderURL = csNew2;

				CheckBoxes();
			}

			// neuen aktuellen Plugin speichern
			iOldPlugin = iInd;
		}
		else
		{
			DWORD dwService;
			CString csServer;
			CString csObject;
			INTERNET_PORT nPort;

			// ... und auseinandernehmen
			if (AfxParseURL(m_ServerName, dwService, csServer, csObject, nPort))
				// File-Protokoll?
				if (dwService == AFX_INET_SERVICE_FILE)
					// ... dann alles nehmen
					csObject = m_ServerName;
			// alten bernehmen
			m_csOldFolderURL = csObject;
		}
	}
	else
		// Fehlermeldung
		AfxMessageBox("Zu nutzender Publishing-Worker konnte "
			"nicht ermittelt werden!");
}

void CAddEntry::CheckBoxes()
{
	// OK-Button holen
	CButton* pOK = (CButton*)GetDlgItem(IDOK);
	ASSERT_VALID(pOK);

	// aktuellen Eintrag holen
	CEdit* pEdit0 = (CEdit*)GetDlgItem(IDC_ADRESSNAME);
	CEdit* pEdit1 = (CEdit*)GetDlgItem(IDC_SERVERNAME);
	CEdit* pEdit2 = (CEdit*)GetDlgItem(IDC_SERVERSTARTFOLDER);
	ASSERT_VALID(pEdit0);
	ASSERT_VALID(pEdit1);
	ASSERT_VALID(pEdit2);

	// alles ok?
	if (pEdit0 && pEdit1 && pEdit2 && pOK)
	{
		CString csCurrent0;
		CString csCurrent1;
		CString csCurrent2;

		// Eintrag holen
		pEdit0->GetWindowText(csCurrent0);
		pEdit1->GetWindowText(csCurrent1);
		pEdit2->GetWindowText(csCurrent2);

		// steht irgendwas drin?
		if (csCurrent0.GetLength() && csCurrent1.GetLength() && 
			csCurrent2.GetLength())
			// ... dann aktivieren
			pOK->EnableWindow(true);
		else
			// ... sonst deaktivieren
			pOK->EnableWindow(false);
	}
}


BOOL CAddEntry::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	int iNew;
	CPluginDLL* pPlugin;
	CComboBox* pBox = (CComboBox*)GetDlgItem(IDC_WORKERPLUGINCOMBO);
	ASSERT_VALID(pBox);

	CDialog::OnInitDialog();

	// gltige Belegung?
	if (pAllPlugins && pBox)
	{
		// erst alle internen Plugins suchen
		pAllPlugins->FillPluginArray(
			&InternalPlugins, PLUGINTYPE_PUBLISHING_WORKER);

		// ... dann neu mit Werten fllen
		for (int i=0; i<InternalPlugins.GetPluginCount(); i++)
		{
			// Plugin holen
			pPlugin = InternalPlugins.GetPluginAt(i);

			if (pPlugin)
			{
				// ... dann hinzufgen
				iNew = pBox->AddString(pPlugin->GetPluginName());
				pBox->SetItemData(iNew, i);
			}
		}

		// Position setzen
		iOldPlugin = -1;

		// ersten Eintrag markieren
		pBox->SetCurSel(0);
		FindProtocol();
	}

	// alles mal testen!
	CheckBoxes();

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX-Eigenschaftenseiten sollten FALSE zurckgeben
}

void CAddEntry::OnOK() 
{
	CPluginDLL* pPlugin;
	int iInd;
	int iNew = IDYES;
	CString csWEB;
	CString csServer;
	CString csObject;
	INTERNET_PORT nPort;
	int iService;
	CComboBox* pBox = (CComboBox*)GetDlgItem(IDC_WORKERPLUGINCOMBO);
	CEdit* pEdit1 = (CEdit*)GetDlgItem(IDC_SERVERNAME);
	ASSERT_VALID(pBox);
	ASSERT_VALID(pEdit1);

	// gltig?
	if (pBox && pEdit1)
	{
		// Index holen
		iInd = pBox->GetItemData(pBox->GetCurSel());
		// den Plugin holen
		pPlugin = InternalPlugins.GetPluginAt(iInd);
		// gltig?
		if (pPlugin)
		{
			// die Eingabe holen
			pEdit1->GetWindowText(csWEB);

			// ... mal schauen, ob Protokolle kompatibel
			AfxParseURL(csWEB, (DWORD&)iService, csServer, csObject, nPort);
			// sind beide kompatibel?
			if (iService != ((CPubWorkerPluginDLL*)pPlugin)->GetSupportedService())
				// ... wenn nicht, dann Fehlermeldung
				iNew = AfxMessageBox("Das verwendete Dateiprotokoll und das "
					"Protokoll des aktuellen\nPublishing-Workers sind nicht "
					"kompatibel!\n\nSoll es trotzdem verwendet werden?",
					MB_YESNO | MB_ICONQUESTION | MB_DEFBUTTON2);

			// ... nur bernehmen, wenn gewollt!
			if (iNew == IDYES)
				m_csPluginDLL = pPlugin->GetPluginFileName();
		}
	}
	else
		// Fehlermeldung
		AfxMessageBox("Zu nutzender Publishing-Worker konnte nicht ermittelt werden!");

	// nur raus, wenn gewollt!
	if (iNew == IDYES)
	{
		// alles updaten
		UpdateData(true);

		// das war's ... und raus
		CDialog::OnOK();
	}
}

void CAddEntry::OnChangeServerstartfolder() 
{
	// testen!
	CheckBoxes();
}

void CAddEntry::OnChangeServername() 
{
	CString csURL;
	DWORD dwService;
	CString csServer;
	CString csObject;
	CString csNewObject;
	CString csCurrent;
	INTERNET_PORT nPort;
	CEdit* pEdit1 = (CEdit*)GetDlgItem(IDC_SERVERNAME);
	CEdit* pEdit2 = (CEdit*)GetDlgItem(IDC_SERVERSTARTFOLDER);
	ASSERT_VALID(pEdit1);
	ASSERT_VALID(pEdit2);

	// alles ok?
	if (pEdit1 && pEdit2)
	{
		// Sandard setzen
		csNewObject = "/";

		// URL holen
		pEdit1->GetWindowText(csURL);
		pEdit2->GetWindowText(csCurrent);

		// ... und auseinandernehmen
		if (AfxParseURL(csURL, dwService, csServer, csObject, nPort))
		{
			// nur aktualisieren, wenn nicht gleich!
			if (m_csOldFolderURL == csCurrent)
			{
				// neuen setzen
				csNewObject = csObject;
				// File-Protokoll?
				if (dwService == AFX_INET_SERVICE_FILE)
				{
					// ... dann alles nehmen
					csNewObject = csURL;
					csObject = csURL;
				}
			}
			else
				// ... ansonsten am Text nix verndern
				csNewObject = csCurrent;
		}

		// alles neue setzen
		pEdit2->SetWindowText(csNewObject);
		m_csOldFolderURL = csObject;
	}

	// testen!
	CheckBoxes();
}

void CAddEntry::OnSelchangeWorkerplugincombo() 
{
	// Protokoll anwhlen
	FindProtocol();
}

void CAddEntry::OnChangeAdressname() 
{
	// testen!
	CheckBoxes();
}
