// ServerbookNormal.cpp: Implementierungsdatei
//

#include "stdafx.h"
#include "ServerbookNormal.h"
#include "addentry.h"
#include "tools.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// Dialogfeld CServerbookNormal 


CServerbookNormal::CServerbookNormal(CWnd* pParent /*=NULL*/)
	: CDialog(CServerbookNormal::IDD, pParent)
{
	//{{AFX_DATA_INIT(CServerbookNormal)
		// HINWEIS: Der Klassen-Assistent fgt hier Elementinitialisierung ein
	//}}AFX_DATA_INIT

	pRecordset = NULL;
}


void CServerbookNormal::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CServerbookNormal)
	DDX_Control(pDX, IDC_STARTFOLDER, m_StartFolder);
	DDX_Control(pDX, IDC_SERVERNAME, m_ServerName);
	DDX_Control(pDX, IDC_PLUGINFILENAME, m_PluginFilename);
	DDX_Control(pDX, IDC_BEZEICHNUNG, m_Bezeichnung);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CServerbookNormal, CDialog)
	//{{AFX_MSG_MAP(CServerbookNormal)
	ON_LBN_SELCHANGE(IDC_BEZEICHNUNG, OnSelchangeBezeichnung)
	ON_BN_CLICKED(IDC_ADDADRESS, OnAddadress)
	ON_BN_CLICKED(IDC_DELADRESS, OnDeladress)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// Behandlungsroutinen fr Nachrichten CServerbookNormal 

BOOL CServerbookNormal::OnInitDialog() 
{
	CDialog::OnInitDialog();

	// das anzeigen
	BuildComboBoxRecSet();

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX-Eigenschaftenseiten sollten FALSE zurckgeben
}

void CServerbookNormal::FindCurrentRecord(bool bUpdate)
{
	// ... alles suchen
	int iInd = m_Bezeichnung.GetCurSel();

	// etwas markiert?
	if (iInd != LB_ERR)
	{
		COleVariant variant;
		int iPos;

		// aktuellen holen
		iPos = m_Bezeichnung.GetItemData(iInd);
		// und in der Datenbank danach suchen
		pRecordset->MoveFirst();
		// war etwas drin?
		if (!pRecordset->IsBOF() && !pRecordset->IsEOF())
		{
			// und dorthin gehen
			pRecordset->Move(iPos);
			// alle Einstellungen holen und merken
			pRecordset->GetFieldValue("Servername", variant);
			currentAdress.csServer = variant.pbVal;
			pRecordset->GetFieldValue("Startverzeichnis", variant);
			currentAdress.csStartURL = variant.pbVal;
			pRecordset->GetFieldValue("Plugindateiname", variant);
			currentAdress.csPluginFileName = variant.pbVal;

			// soll alles neu angezeigt werden?
			if (bUpdate)
			{
				// ... dann neu anzeigen
				m_ServerName.SetWindowText(currentAdress.csServer);
				m_StartFolder.SetWindowText(currentAdress.csStartURL);
				m_PluginFilename.SetWindowText(currentAdress.csPluginFileName);
			}
		}
	}
	else
	{
		// alles lschen
		currentAdress.csServer = "";
		currentAdress.csStartURL = "";
		currentAdress.csPluginFileName = "";
		// ... dann neu anzeigen
		m_ServerName.SetWindowText("- keine aktuelle Serveradresse -");
		m_StartFolder.SetWindowText("- kein aktueller Startpfad -");
		m_PluginFilename.SetWindowText("- kein aktueller Plugin -");
	}

	// alles abchecken
	CheckBoxes();
}

void CServerbookNormal::OnSelchangeBezeichnung() 
{
	// das anzeigen
	FindCurrentRecord();
}

void CServerbookNormal::OnOK() 
{
	// aktuellen Eintrag suchen
	FindCurrentRecord();
	
	CDialog::OnOK();
}

void CServerbookNormal::OnAddadress() 
{
	CAddEntry newAdress;

	// alles setzen
	newAdress.pAllPlugins = GetCurrentPluginArray();

	// .. und anzeigen
	if (newAdress.DoModal() == IDOK && pRecordset)
	{
		// und nun neuen Datensatz erzeugen
		pRecordset->AddNew();
		pRecordset->Update();
		// ... und zum neuen wechseln
		pRecordset->SetBookmark(pRecordset->GetLastModifiedBookmark());

		// ... und Editmode
		pRecordset->Edit();
		// Felder eintragen
		pRecordset->SetFieldValue("Bezeichnung", 
			(LPCSTR)newAdress.m_AdressName);
		pRecordset->SetFieldValue("Servername", 
			(LPCSTR)newAdress.m_ServerName);
		pRecordset->SetFieldValue("Startverzeichnis", 
			(LPCSTR)newAdress.m_ServerStartFolder);
		pRecordset->SetFieldValue("Plugindateiname", 
			(LPCSTR)newAdress.m_csPluginDLL);
		// ... dann updaten
		pRecordset->Update();

		// ... und alles neu aufbauen
		BuildComboBoxRecSet();
	}
}

void CServerbookNormal::BuildComboBoxRecSet()
{
	// alles vorher lschen
	m_Bezeichnung.ResetContent();

	// ist ein Recordset gegeben
	if (pRecordset)
	{
		int i = 0;
		int iCurr;
		COleVariant variant;

		// noch vor ersten?
		if (!pRecordset->IsBOF())
			// zum ersten gehen
			pRecordset->MoveFirst();

		// berhaupt was da?
		if (!pRecordset->IsBOF() && !pRecordset->IsEOF())
		{
			// alle Datenstze durchlaufen
			while (!pRecordset->IsEOF())
			{
				// holen
				pRecordset->GetFieldValue("Bezeichnung", variant);
				// eintragen
				iCurr = m_Bezeichnung.AddString((const char*)variant.pbVal);
				m_Bezeichnung.SetItemData(iCurr, i++), 

				// nchster
				pRecordset->MoveNext();
			}
		}
	}
	
	// zum ersten setzen
	m_Bezeichnung.SetCurSel(0);
	FindCurrentRecord();
}

void CServerbookNormal::OnDeladress() 
{
	// den aktuellen Index holen	
	int iInd = m_Bezeichnung.GetCurSel();
	int iID = IDYES;

	// Messagebox anzeigen
	iID = AfxMessageBox("Das Lschen der Adresse ist nicht rckgngig "
		"zu machen!\nSoll wirklich gelscht werden?", 
		MB_YESNO | MB_ICONQUESTION);

	// etwas markiert?
	if (iInd != LB_ERR && iID == IDYES)
	{
		int iPos;

		// aktuellen holen
		iPos = m_Bezeichnung.GetItemData(iInd);
		// und in der Datenbank danach suchen
		pRecordset->MoveFirst();
		// war etwas drin?
		if (!pRecordset->IsBOF() && !pRecordset->IsEOF())
		{
			// und dorthin gehen
			pRecordset->Move(iPos);
			// ... und lschen
			pRecordset->Delete();

			// alles neu anzeigen
			BuildComboBoxRecSet();
		}
	}
}

void CServerbookNormal::CheckBoxes()
{
	// aktuelle ComboBox holen
	CButton* pButton = (CButton*)GetDlgItem(IDC_DELADRESS);
	ASSERT_VALID(pButton);

	// alles ok?
	if (pButton)
	{
		// steht was drin und was angeklickt?
		if (m_Bezeichnung.GetCount() && 
			m_Bezeichnung.GetCurSel() != LB_ERR)
			pButton->EnableWindow(true);
		else
			pButton->EnableWindow(false);
	}
}
