// SrvBook.cpp : Legt die Initialisierungsroutinen fr die DLL fest.
//

#include "stdafx.h"
#include <afxdllx.h>

#include "plugintypes.h"
#include "about.h"
#include "tools.h"
#include "afxdao.h"
#include "serverbooknormal.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

SERVERADRESS adress;
CDaoDatabase* pDatabase;
CDaoRecordset* pRecordSet;
int iResult;


static AFX_EXTENSION_MODULE SrvBookDLL = { NULL, NULL };

void OpenMDB()
{
	// aktuelles Plugindir holen
	CString csFile = GetCurrentPluginDir()+ "\\DATA\\srvbook.mdb";

	// Datenbasis erzeugen und ffnen
	pDatabase = new CDaoDatabase();
	// alles ok?
	if (pDatabase)
	{
		// ... dann ffnen
		pDatabase->Open(csFile);

		// ... und nun die Tabelle erzeugen / ffnen
		pRecordSet = new CDaoRecordset(pDatabase);
		// ... alles ok?
		if (pRecordSet)
			pRecordSet->Open(dbOpenTable, "Serverbook");
	}
}

void CloseMDB()
{
	// Recordset schlieen
	if (pRecordSet)
		pRecordSet->Close();

	// Datenbasis schlieen
	if (pDatabase)
		pDatabase->Close();
}

extern "C" int APIENTRY
DllMain(HINSTANCE hInstance, DWORD dwReason, LPVOID lpReserved)
{
	// Entfernen Sie dies, wenn Sie lpReserved verwenden
	UNREFERENCED_PARAMETER(lpReserved);

	if (dwReason == DLL_PROCESS_ATTACH)
	{
		TRACE0("SRVBOOK.DLL Initializing!\n");
		
		// One-Time-Initialisierung der Erweiterungs-DLL
		if (!AfxInitExtensionModule(SrvBookDLL, hInstance))
			return 0;

		// Diese DLL in Ressourcenkette einfgen
		// HINWEIS: Wird diese Erweiterungs-DLL implizit durch eine regulre
		//  MFC-DLL (wie z.B. ein ActiveX-Steuerelement) anstelle einer
		//  MFC-Anwendung eingebunden, dann mchten Sie mglicherweise diese
		//  Zeile aus DllMain entfernen und eine eigene Funktion einfgen,
		//  die von dieser Erweiterungs-DLL exportiert wird. Die regulre DLL,
		//  die diese Erweiterungs-DLL verwendet, sollte dann explizit die 
		//  Initialisierungsfunktion der Erweiterungs-DLL aufrufen. Anderenfalls 
		//  wird das CDynLinkLibrary-Objekt nicht mit der Recourcenkette der 
		//  regulren DLL verbunden, was zu ernsthaften Problemen
		//  fhren kann.

		new CDynLinkLibrary(SrvBookDLL);
	}
	else if (dwReason == DLL_PROCESS_DETACH)
	{
		TRACE0("SRVBOOK.DLL Terminating!\n");
		// Bibliothek vor dem Aufruf der Destruktoren schlieen
		AfxTermExtensionModule(SrvBookDLL);
	}
	return 1;   // OK
}

extern "C" void GetPluginName(CString* name)
{
	*name = "Standard-ServerBook v1.0";
}

extern "C" void GetPluginInfo(CString* info)
{
	*info = "Standard-Plugin fr Uploader v1.0 zur Verwaltung eines Serverbooks.";
}

extern "C" void GetPluginTypeAsString(CString* type)
{
	*type = "PLUGINTYPE_SRVBOOKEXTENSION";
}

extern "C" void GetPluginTypeAsInteger(int* type)
{
	*type = PLUGINTYPE_SRVBOOKEXTENSION;
}

extern "C" void ShowPluginDialog()
{
	CAbout about;

	// anzeigen
	about.DoModal();
}

extern "C" void ShowServerBook(int iMode)
{
	CServerbookNormal serverBook;

	// DLL intialisieren
	OpenMDB();

	// letztes merken
	serverBook.pRecordset = pRecordSet;
	iResult = serverBook.DoModal();
	// rausschreiben
	adress = serverBook.currentAdress;

	// DLL reallokieren
	CloseMDB();
}

extern "C" int GetLastServerBookEntry(void* pAdress)
{
	// jetzt alles bernehmen
	*((SERVERADRESS*)pAdress) = adress;
	// und Resultat rausliefern
	return iResult;
}

